/* A Bison parser, made by GNU Bison 3.5.1.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 1

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         OCTAVE_STYPE
/* Substitute the variable and function names.  */
#define yyparse         octave_parse
#define yypush_parse    octave_push_parse
#define yypull_parse    octave_pull_parse
#define yypstate_new    octave_pstate_new
#define yypstate_delete octave_pstate_delete
#define yypstate        octave_pstate
#define yylex           octave_lex
#define yyerror         octave_error
#define yydebug         octave_debug
#define yynerrs         octave_nerrs

/* First part of user prologue.  */
#line 30 "../libinterp/parse-tree/oct-parse.yy"


#define YYDEBUG 1

#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif

#include <cassert>
#include <cstdio>
#include <cstdlib>

#include <iostream>
#include <map>
#include <sstream>

#include "Matrix.h"
#include "cmd-edit.h"
#include "cmd-hist.h"
#include "file-ops.h"
#include "file-stat.h"
#include "oct-env.h"
#include "oct-time.h"
#include "quit.h"

#include "Cell.h"
#include "anon-fcn-validator.h"
#include "builtin-defun-decls.h"
#include "defun.h"
#include "dynamic-ld.h"
#include "error.h"
#include "input.h"
#include "interpreter-private.h"
#include "interpreter.h"
#include "lex.h"
#include "load-path.h"
#include "lo-sysdep.h"
#include "oct-hist.h"
#include "oct-map.h"
#include "ov-classdef.h"
#include "ov-fcn-handle.h"
#include "ov-usr-fcn.h"
#include "ov-null-mat.h"
#include "pager.h"
#include "parse.h"
#include "pt-all.h"
#include "pt-eval.h"
#include "symtab.h"
#include "token.h"
#include "unwind-prot.h"
#include "utils.h"
#include "variables.h"

// oct-parse.h must be included after pt-all.h
#include "oct-parse.h"

extern int octave_lex (YYSTYPE *, void *);

// Forward declarations for some functions defined at the bottom of
// the file.

static void yyerror (octave::base_parser& parser, const char *s);

#define lexer (parser.get_lexer ())
#define scanner lexer.m_scanner

#if defined (HAVE_PRAGMA_GCC_DIAGNOSTIC)
   // Disable this warning for code that is generated by Bison,
   // including grammar rules.  Push the current state so we can
   // restore the warning state prior to functions we define at
   // the bottom of the file.
#  pragma GCC diagnostic push
#  pragma GCC diagnostic ignored "-Wold-style-cast"
#endif


#line 158 "libinterp/parse-tree/oct-parse.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_OCTAVE_LIBINTERP_PARSE_TREE_OCT_PARSE_H_INCLUDED
# define YY_OCTAVE_LIBINTERP_PARSE_TREE_OCT_PARSE_H_INCLUDED
/* Debug traces.  */
#ifndef OCTAVE_DEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define OCTAVE_DEBUG 1
#  else
#   define OCTAVE_DEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define OCTAVE_DEBUG 0
# endif /* ! defined YYDEBUG */
#endif  /* ! defined OCTAVE_DEBUG */
#if OCTAVE_DEBUG
extern int octave_debug;
#endif

/* Token type.  */
#ifndef OCTAVE_TOKENTYPE
# define OCTAVE_TOKENTYPE
  enum octave_tokentype
  {
    ADD_EQ = 258,
    SUB_EQ = 259,
    MUL_EQ = 260,
    DIV_EQ = 261,
    LEFTDIV_EQ = 262,
    POW_EQ = 263,
    EMUL_EQ = 264,
    EDIV_EQ = 265,
    ELEFTDIV_EQ = 266,
    EPOW_EQ = 267,
    AND_EQ = 268,
    OR_EQ = 269,
    EXPR_AND_AND = 270,
    EXPR_OR_OR = 271,
    EXPR_AND = 272,
    EXPR_OR = 273,
    EXPR_NOT = 274,
    EXPR_LT = 275,
    EXPR_LE = 276,
    EXPR_EQ = 277,
    EXPR_NE = 278,
    EXPR_GE = 279,
    EXPR_GT = 280,
    LEFTDIV = 281,
    EMUL = 282,
    EDIV = 283,
    ELEFTDIV = 284,
    EPLUS = 285,
    EMINUS = 286,
    HERMITIAN = 287,
    TRANSPOSE = 288,
    PLUS_PLUS = 289,
    MINUS_MINUS = 290,
    POW = 291,
    EPOW = 292,
    NUM = 293,
    IMAG_NUM = 294,
    STRUCT_ELT = 295,
    NAME = 296,
    END = 297,
    DQ_STRING = 298,
    SQ_STRING = 299,
    FOR = 300,
    PARFOR = 301,
    WHILE = 302,
    DO = 303,
    UNTIL = 304,
    IF = 305,
    ELSEIF = 306,
    ELSE = 307,
    SWITCH = 308,
    CASE = 309,
    OTHERWISE = 310,
    BREAK = 311,
    CONTINUE = 312,
    FUNC_RET = 313,
    UNWIND = 314,
    CLEANUP = 315,
    TRY = 316,
    CATCH = 317,
    GLOBAL = 318,
    PERSISTENT = 319,
    FCN_HANDLE = 320,
    CLASSDEF = 321,
    PROPERTIES = 322,
    METHODS = 323,
    EVENTS = 324,
    ENUMERATION = 325,
    METAQUERY = 326,
    SUPERCLASSREF = 327,
    FQ_IDENT = 328,
    GET = 329,
    SET = 330,
    FCN = 331,
    LEXICAL_ERROR = 332,
    END_OF_INPUT = 333,
    INPUT_FILE = 334,
    UNARY = 335
  };
#endif
/* Tokens.  */
#define ADD_EQ 258
#define SUB_EQ 259
#define MUL_EQ 260
#define DIV_EQ 261
#define LEFTDIV_EQ 262
#define POW_EQ 263
#define EMUL_EQ 264
#define EDIV_EQ 265
#define ELEFTDIV_EQ 266
#define EPOW_EQ 267
#define AND_EQ 268
#define OR_EQ 269
#define EXPR_AND_AND 270
#define EXPR_OR_OR 271
#define EXPR_AND 272
#define EXPR_OR 273
#define EXPR_NOT 274
#define EXPR_LT 275
#define EXPR_LE 276
#define EXPR_EQ 277
#define EXPR_NE 278
#define EXPR_GE 279
#define EXPR_GT 280
#define LEFTDIV 281
#define EMUL 282
#define EDIV 283
#define ELEFTDIV 284
#define EPLUS 285
#define EMINUS 286
#define HERMITIAN 287
#define TRANSPOSE 288
#define PLUS_PLUS 289
#define MINUS_MINUS 290
#define POW 291
#define EPOW 292
#define NUM 293
#define IMAG_NUM 294
#define STRUCT_ELT 295
#define NAME 296
#define END 297
#define DQ_STRING 298
#define SQ_STRING 299
#define FOR 300
#define PARFOR 301
#define WHILE 302
#define DO 303
#define UNTIL 304
#define IF 305
#define ELSEIF 306
#define ELSE 307
#define SWITCH 308
#define CASE 309
#define OTHERWISE 310
#define BREAK 311
#define CONTINUE 312
#define FUNC_RET 313
#define UNWIND 314
#define CLEANUP 315
#define TRY 316
#define CATCH 317
#define GLOBAL 318
#define PERSISTENT 319
#define FCN_HANDLE 320
#define CLASSDEF 321
#define PROPERTIES 322
#define METHODS 323
#define EVENTS 324
#define ENUMERATION 325
#define METAQUERY 326
#define SUPERCLASSREF 327
#define FQ_IDENT 328
#define GET 329
#define SET 330
#define FCN 331
#define LEXICAL_ERROR 332
#define END_OF_INPUT 333
#define INPUT_FILE 334
#define UNARY 335

/* Value type.  */
#if ! defined OCTAVE_STYPE && ! defined OCTAVE_STYPE_IS_DECLARED
union OCTAVE_STYPE
{
#line 131 "../libinterp/parse-tree/oct-parse.yy"

  int dummy_type;

  // The type of the basic tokens returned by the lexer.
  octave::token *tok_val;

  // Comment strings that we need to deal with mid-rule.
  octave::comment_list *comment_type;

  // Types for the nonterminals we generate.
  char punct_type;
  octave::tree *tree_type;
  octave::tree_matrix *tree_matrix_type;
  octave::tree_cell *tree_cell_type;
  octave::tree_expression *tree_expression_type;
  octave::tree_constant *tree_constant_type;
  octave::tree_fcn_handle *tree_fcn_handle_type;
  octave::tree_superclass_ref *tree_superclass_ref_type;
  octave::tree_metaclass_query *tree_metaclass_query_type;
  octave::tree_function_def *tree_function_def_type;
  octave::tree_anon_fcn_handle *tree_anon_fcn_handle_type;
  octave::tree_identifier *tree_identifier_type;
  octave::tree_index_expression *tree_index_expression_type;
  octave::tree_colon_expression *tree_colon_expression_type;
  octave::tree_argument_list *tree_argument_list_type;
  octave::tree_parameter_list *tree_parameter_list_type;
  octave::tree_command *tree_command_type;
  octave::tree_if_command *tree_if_command_type;
  octave::tree_if_clause *tree_if_clause_type;
  octave::tree_if_command_list *tree_if_command_list_type;
  octave::tree_switch_command *tree_switch_command_type;
  octave::tree_switch_case *tree_switch_case_type;
  octave::tree_switch_case_list *tree_switch_case_list_type;
  octave::tree_decl_elt *tree_decl_elt_type;
  octave::tree_decl_init_list *tree_decl_init_list_type;
  octave::tree_decl_command *tree_decl_command_type;
  octave::tree_statement *tree_statement_type;
  octave::tree_statement_list *tree_statement_list_type;
  octave_user_function *octave_user_function_type;

  octave::tree_classdef *tree_classdef_type;
  octave::tree_classdef_attribute* tree_classdef_attribute_type;
  octave::tree_classdef_attribute_list* tree_classdef_attribute_list_type;
  octave::tree_classdef_superclass* tree_classdef_superclass_type;
  octave::tree_classdef_superclass_list* tree_classdef_superclass_list_type;
  octave::tree_classdef_body* tree_classdef_body_type;
  octave::tree_classdef_property* tree_classdef_property_type;
  octave::tree_classdef_property_list* tree_classdef_property_list_type;
  octave::tree_classdef_properties_block* tree_classdef_properties_block_type;
  octave::tree_classdef_methods_list* tree_classdef_methods_list_type;
  octave::tree_classdef_methods_block* tree_classdef_methods_block_type;
  octave::tree_classdef_event* tree_classdef_event_type;
  octave::tree_classdef_events_list* tree_classdef_events_list_type;
  octave::tree_classdef_events_block* tree_classdef_events_block_type;
  octave::tree_classdef_enum* tree_classdef_enum_type;
  octave::tree_classdef_enum_list* tree_classdef_enum_list_type;
  octave::tree_classdef_enum_block* tree_classdef_enum_block_type;

#line 437 "libinterp/parse-tree/oct-parse.cc"

};
typedef union OCTAVE_STYPE OCTAVE_STYPE;
# define OCTAVE_STYPE_IS_TRIVIAL 1
# define OCTAVE_STYPE_IS_DECLARED 1
#endif



#ifndef YYPUSH_MORE_DEFINED
# define YYPUSH_MORE_DEFINED
enum { YYPUSH_MORE = 4 };
#endif

typedef struct octave_pstate octave_pstate;

int octave_parse (octave::base_parser& parser);
int octave_push_parse (octave_pstate *ps, int pushed_char, OCTAVE_STYPE const *pushed_val, octave::base_parser& parser);
int octave_pull_parse (octave_pstate *ps, octave::base_parser& parser);
octave_pstate * octave_pstate_new (void);
void octave_pstate_delete (octave_pstate *ps);

#endif /* !YY_OCTAVE_LIBINTERP_PARSE_TREE_OCT_PARSE_H_INCLUDED  */



#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined OCTAVE_STYPE_IS_TRIVIAL && OCTAVE_STYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  106
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1525

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  98
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  108
/* YYNRULES -- Number of rules.  */
#define YYNRULES  285
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  524

#define YYUNDEFTOK  2
#define YYMAXUTOK   335


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      19,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       9,    10,     7,     6,    17,     5,    15,     8,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,    18,
       2,     3,     2,     2,    16,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    11,     2,    12,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    13,     2,    14,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97
};

#if OCTAVE_DEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   383,   383,   391,   400,   407,   413,   417,   419,   424,
     425,   429,   433,   435,   440,   441,   445,   453,   458,   465,
     467,   469,   481,   493,   495,   506,   515,   526,   535,   537,
     541,   543,   545,   549,   553,   555,   571,   575,   577,   598,
     599,   605,   607,   613,   619,   628,   636,   648,   661,   663,
     665,   667,   672,   674,   676,   678,   687,   696,   704,   706,
     708,   710,   717,   724,   733,   742,   744,   746,   748,   760,
     772,   784,   796,   798,   800,   802,   809,   811,   813,   815,
     817,   819,   821,   823,   825,   827,   829,   831,   833,   835,
     837,   839,   841,   845,   847,   849,   851,   863,   875,   887,
     899,   901,   908,   910,   912,   914,   916,   920,   932,   947,
     949,   951,   953,   955,   957,   959,   961,   963,   965,   967,
     969,   973,   987,   989,   991,   993,   995,   997,   999,  1001,
    1003,  1005,  1007,  1009,  1011,  1015,  1030,  1037,  1045,  1047,
    1049,  1051,  1053,  1055,  1057,  1065,  1070,  1077,  1079,  1087,
    1092,  1094,  1107,  1109,  1117,  1127,  1129,  1136,  1144,  1151,
    1162,  1175,  1188,  1189,  1191,  1193,  1200,  1202,  1209,  1218,
    1231,  1243,  1250,  1262,  1276,  1288,  1309,  1314,  1319,  1327,
    1340,  1353,  1371,  1383,  1400,  1411,  1412,  1416,  1423,  1432,
    1433,  1450,  1452,  1461,  1463,  1471,  1480,  1498,  1518,  1520,
    1535,  1539,  1548,  1552,  1580,  1599,  1608,  1617,  1627,  1639,
    1652,  1687,  1694,  1708,  1724,  1737,  1753,  1754,  1763,  1765,
    1774,  1776,  1783,  1793,  1798,  1806,  1812,  1821,  1825,  1827,
    1829,  1831,  1833,  1840,  1847,  1854,  1864,  1876,  1890,  1892,
    1901,  1903,  1912,  1924,  1938,  1943,  1950,  1953,  1952,  1967,
    1969,  1973,  1981,  1995,  2007,  2020,  2022,  2031,  2035,  2047,
    2060,  2062,  2071,  2085,  2092,  2100,  2103,  2109,  2113,  2119,
    2125,  2131,  2140,  2141,  2146,  2147,  2151,  2157,  2165,  2171,
    2177,  2183,  2189,  2195,  2204,  2205
};
#endif

#if OCTAVE_DEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "'='", "':'", "'-'", "'+'", "'*'", "'/'",
  "'('", "')'", "'['", "']'", "'{'", "'}'", "'.'", "'@'", "','", "';'",
  "'\\n'", "ADD_EQ", "SUB_EQ", "MUL_EQ", "DIV_EQ", "LEFTDIV_EQ", "POW_EQ",
  "EMUL_EQ", "EDIV_EQ", "ELEFTDIV_EQ", "EPOW_EQ", "AND_EQ", "OR_EQ",
  "EXPR_AND_AND", "EXPR_OR_OR", "EXPR_AND", "EXPR_OR", "EXPR_NOT",
  "EXPR_LT", "EXPR_LE", "EXPR_EQ", "EXPR_NE", "EXPR_GE", "EXPR_GT",
  "LEFTDIV", "EMUL", "EDIV", "ELEFTDIV", "EPLUS", "EMINUS", "HERMITIAN",
  "TRANSPOSE", "PLUS_PLUS", "MINUS_MINUS", "POW", "EPOW", "NUM",
  "IMAG_NUM", "STRUCT_ELT", "NAME", "END", "DQ_STRING", "SQ_STRING", "FOR",
  "PARFOR", "WHILE", "DO", "UNTIL", "IF", "ELSEIF", "ELSE", "SWITCH",
  "CASE", "OTHERWISE", "BREAK", "CONTINUE", "FUNC_RET", "UNWIND",
  "CLEANUP", "TRY", "CATCH", "GLOBAL", "PERSISTENT", "FCN_HANDLE",
  "CLASSDEF", "PROPERTIES", "METHODS", "EVENTS", "ENUMERATION",
  "METAQUERY", "SUPERCLASSREF", "FQ_IDENT", "GET", "SET", "FCN",
  "LEXICAL_ERROR", "END_OF_INPUT", "INPUT_FILE", "UNARY", "$accept",
  "input", "simple_list", "simple_list1", "opt_list", "list", "list1",
  "opt_fcn_list", "fcn_list", "fcn_list1", "statement", "word_list_cmd",
  "word_list", "identifier", "superclass_identifier", "meta_identifier",
  "string", "constant", "matrix", "matrix_rows", "cell", "cell_rows",
  "cell_or_matrix_row", "fcn_handle", "anon_fcn_handle", "primary_expr",
  "magic_colon", "magic_tilde", "arg_list", "indirect_ref_op", "oper_expr",
  "power_expr", "colon_expr", "simple_expr", "assign_lhs", "assign_expr",
  "expression", "command", "declaration", "decl1", "decl_param_init",
  "decl2", "select_command", "if_command", "if_cmd_list", "if_cmd_list1",
  "elseif_clause", "else_clause", "switch_command", "case_list",
  "case_list1", "switch_case", "default_case", "loop_command",
  "jump_command", "except_command", "push_fcn_symtab", "param_list_beg",
  "param_list_end", "opt_param_list", "param_list", "param_list1",
  "param_list2", "param_list_elt", "return_list", "return_list1",
  "parsing_local_fcns", "push_script_symtab", "begin_file", "file",
  "function_beg", "fcn_name", "function_end", "function", "classdef_beg",
  "classdef", "opt_attr_list", "attr_list", "attr", "opt_superclass_list",
  "superclass_list", "superclass", "class_body", "properties_block",
  "property_list", "class_property", "methods_block", "method_decl1",
  "method_decl", "$@1", "method", "methods_list", "events_block",
  "events_list", "class_event", "enum_block", "enum_list", "class_enum",
  "stmt_begin", "anon_fcn_begin", "stash_comment", "parse_error",
  "sep_no_nl", "opt_sep_no_nl", "opt_nl", "nl", "sep", "opt_sep", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,    61,    58,    45,    43,    42,    47,    40,
      41,    91,    93,   123,   125,    46,    64,    44,    59,    10,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335
};
# endif

#define YYPACT_NINF (-397)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-273)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     593,  -397,  1257,  1257,  1245,  1009,  1009,    26,  -397,  -397,
    1257,  1257,  1257,  -397,  -397,  -397,  -397,  -397,  -397,  -397,
    -397,  -397,  -397,  -397,  -397,  -397,  -397,  -397,  -397,     1,
       1,  -397,  -397,  -397,  -397,    69,    -9,   185,  -397,  -397,
     154,  -397,  -397,  -397,  -397,  -397,  -397,  -397,  -397,  -397,
    1409,  -397,  1467,   610,  -397,  -397,  -397,  -397,  -397,  -397,
    -397,  -397,  -397,  -397,     9,    45,    96,  -397,  -397,  -397,
    -397,   202,  -397,  -397,   320,   320,   123,  -397,  1185,  1257,
      28,  -397,  -397,  -397,   140,  -397,   195,  -397,  -397,    27,
    -397,   320,   320,   320,  1315,  1350,  1245,   106,  1245,  1245,
     106,   106,   172,     1,  -397,     1,  -397,  -397,  -397,   766,
    -397,   154,  -397,  1257,  1257,  1257,  1257,  1257,  1023,  1090,
    -397,  1257,  1257,  1257,  1257,  1257,  1257,  -397,  -397,  -397,
    -397,  1385,  1385,    23,  1257,  1257,  1257,  1257,  1257,  1257,
    1257,  1257,  1257,  1257,  1245,  1245,  1245,  1245,  1245,  1245,
    1245,  1245,  1245,  1245,  1245,  1245,  1245,  -397,  -397,  -397,
     847,   149,    40,  -397,  -397,  -397,   174,  -397,  1009,  1185,
    -397,  1009,  -397,  -397,  -397,  -397,   194,   199,  -397,   481,
    1245,   393,   209,  1245,   227,  -397,  -397,  -397,  -397,   165,
     928,  -397,   162,   155,   106,   928,   928,  -397,  -397,  -397,
    -397,  1471,   332,   332,   320,   320,  -397,    47,  -397,    90,
     320,   320,   320,   320,   332,   332,  1385,  1385,  1385,  1385,
    1385,  -397,    59,    59,  1245,  -397,   210,   257,   470,   412,
    -397,  -397,  -397,  -397,  -397,  -397,  -397,  -397,  -397,  -397,
    -397,  -397,  -397,  -397,  -397,  -397,  -397,  -397,  -397,  -397,
     138,  -397,   106,  -397,  -397,  -397,  -397,    37,   231,   241,
     256,   261,    26,  1185,  -397,  -397,  -397,  -397,  -397,  -397,
    -397,    17,  -397,  -397,   689,  1245,   702,  1245,   106,  -397,
    -397,  -397,   206,   106,  -397,  -397,  -397,  -397,  -397,   183,
     197,    14,  1245,  1257,  -397,  1185,  -397,    59,    59,    59,
      59,    59,  1104,  1171,  -397,  -397,    30,   271,  -397,   685,
    -397,   274,   106,  -397,  -397,    67,     1,     1,     8,   106,
    -397,  -397,  1245,  -397,  1245,  -397,   928,  1245,   928,   106,
     106,  -397,  -397,   228,   183,  -397,  -397,  -397,  -397,  -397,
    -397,   574,  -397,    48,  -397,   159,  1245,  -397,  -397,  -397,
      19,     1,   193,  -397,     1,  -397,  -397,  -397,    26,   928,
     278,   106,   285,   106,   246,  -397,  -397,  1245,   928,   106,
     106,  -397,  -397,  -397,   106,   106,  -397,  -397,   297,     1,
     305,   148,  -397,   273,   216,  -397,   106,  -397,  -397,   106,
     -14,   106,   928,  1245,   928,  -397,  -397,  -397,  1245,   928,
     928,   928,  -397,  -397,  -397,  -397,    19,   222,   106,   279,
    -397,   193,   928,  -397,  -397,  -397,   928,   260,   314,   268,
     106,  -397,  -397,   275,   283,  1245,  -397,  -397,  -397,   102,
     222,  -397,   -14,   284,  -397,   106,  -397,   928,   106,  -397,
    -397,  -397,  -397,  -397,  -397,  -397,  -397,   106,  -397,  -397,
    -397,  -397,  -397,  -397,  -397,   928,  -397,   928,   274,   274,
     274,   274,   121,   287,  -397,   106,   106,   106,   106,  -397,
    -397,  -397,  -397,  -397,  -397,   178,   -15,   204,   211,  -397,
     312,   106,  -397,  -397,  -397,  -397,  -397,   106,     2,  -397,
    -397,   106,  -397,  -397,   323,   106,  -397,  -397,    24,   289,
      -5,   103,   334,  -397,   218,  1245,   221,  1245,  -397,  -397,
    -397,  -397,  -397,  -397,  -397,  -397,   339,  -397,  -397,  -397,
       1,  -397,    26,  -397
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,   267,     0,     0,     0,    39,    39,     0,   268,   269,
       0,     0,     0,    30,    31,    25,    28,    29,   265,   265,
     265,   265,   265,   265,   176,   177,   178,   265,   265,     0,
       0,    45,    27,    26,   266,     0,     0,   272,     7,    21,
      48,    54,    53,    32,    49,    51,    52,    50,   137,    65,
     109,   110,   135,     0,   136,    19,    20,   138,   139,   152,
     153,   140,   141,   142,     0,     0,   274,   144,   265,   143,
       4,   273,     5,    48,    80,    79,     0,    56,    40,    57,
       0,    34,    59,    60,    41,    58,     0,    37,   183,     0,
     264,    78,    76,    77,     0,     0,     0,   284,     0,     0,
     284,   284,   150,   145,   147,   146,     1,     2,     3,   273,
       6,    22,    23,     0,     0,     0,     0,     0,     0,     0,
      64,     0,     0,     0,     0,     0,     0,    72,    73,    66,
      67,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   205,   202,   276,
       9,   275,     0,   270,   271,    55,    43,    33,    39,    42,
      36,    39,   188,    57,   194,   193,     0,   190,   191,     0,
       0,   121,     0,     0,     0,   263,   278,   279,   280,   285,
       9,   263,     0,   155,   284,     9,     9,   149,   148,     8,
      24,   107,    84,    83,    85,    86,    68,     0,    70,     0,
      91,    89,    90,    92,    87,    88,     0,     0,     0,     0,
       0,    93,    81,    82,     0,    74,   119,   120,   117,   118,
     111,   112,   113,   116,   114,   115,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   213,
       0,    10,   284,    12,   265,   200,   277,     0,     0,     0,
     206,     0,   185,    44,    35,    61,    62,    63,    38,   184,
     187,     0,    47,    46,     0,     0,     0,     0,   284,   281,
     282,   283,     0,   284,   154,   265,   265,   158,   156,   162,
       0,     0,     0,     0,    69,     0,    71,   106,   105,   104,
     102,   103,     0,     0,    94,    95,     0,     0,   203,   285,
      11,   216,   284,   195,   198,     0,     0,     0,     0,   284,
     186,   192,     0,   263,     0,   263,     9,     0,     9,   284,
     284,   265,   265,     0,   164,   166,   163,   265,   181,   265,
     151,   108,    96,     0,    98,     0,     0,   100,    75,    13,
       0,     0,    14,   197,     0,   207,   208,   206,   185,     9,
       0,   284,   122,   284,     0,   171,   157,     0,     9,   284,
     284,   161,   167,   165,   284,   284,    97,    99,     0,     0,
     220,     0,   218,   223,     0,    15,   284,    17,   199,   284,
       0,   284,     9,     0,     9,   170,   263,   160,     0,     9,
       9,     9,   101,   222,   149,   217,     0,     0,   284,   224,
     204,    16,     9,   209,   210,   211,     9,     0,     0,     0,
     284,   263,   169,     0,     0,     0,   219,   227,   225,     0,
       0,    18,     0,     0,   172,   284,   174,     9,   284,   179,
     180,   221,   215,   265,   265,   265,   265,   284,   228,   229,
     230,   231,   226,   212,   173,     9,   159,     9,   216,   216,
     216,   216,     0,     0,   168,   284,   284,   284,   284,   214,
     232,   233,   234,   235,   175,     0,   265,     0,     0,   237,
     240,   284,   238,   243,   250,   249,   251,   284,     0,   254,
     257,   284,   255,   259,     0,   284,   260,   149,   285,     0,
     265,   244,     0,   246,     0,     0,     0,     0,   239,   236,
     242,   252,   245,   247,   253,   256,     0,   258,   261,   241,
       0,   262,   244,   248
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -397,  -397,  -397,  -397,  -134,  -397,  -397,  -397,  -397,  -397,
       5,  -397,  -397,     0,  -397,  -397,   -28,  -397,  -397,  -397,
    -397,  -397,     3,  -397,  -397,   -98,  -155,   -78,   -71,   -59,
      13,   -19,  -397,   324,   -24,  -397,    -2,  -397,  -397,   322,
    -396,   -53,  -397,  -397,  -397,  -397,  -397,  -397,  -397,  -397,
    -397,    21,    22,  -397,  -397,  -397,  -397,  -397,  -397,     6,
      -6,  -397,  -397,    82,  -131,  -397,  -397,  -397,  -397,  -397,
    -397,    42,   -74,  -321,  -397,  -397,  -232,  -397,   -45,  -397,
    -397,   -67,  -397,   -96,  -397,  -118,   -95,  -133,  -397,  -397,
    -111,  -397,   -72,  -397,  -109,   -65,  -397,  -108,  -153,  -397,
      -1,  -397,   365,   366,  -397,  -397,  -246,   110
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    35,    36,    37,   250,   251,   252,   384,   385,   386,
     253,    39,   111,    73,    41,    42,    43,    44,    45,    80,
      46,    86,    81,    47,    48,    49,    82,    83,    84,   133,
      50,   222,    51,    52,    53,    54,    55,    56,    57,   103,
     292,   104,    58,    59,   192,   193,   287,   288,    60,   333,
     334,   335,   336,    61,    62,    63,    64,    89,   270,   319,
     320,   176,   177,   178,   261,   315,   312,    65,    66,    67,
      68,   262,   415,    69,   254,   255,   351,   381,   382,   408,
     409,   428,   447,   448,   481,   482,   449,   503,   485,   520,
     486,   487,   450,   491,   492,   451,   495,   496,   278,   179,
     488,    70,    71,    72,   160,   161,   189,   190
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      40,    90,    76,    85,    85,    38,   309,   166,   425,    87,
     107,   174,   112,   257,   265,    74,    75,    94,    95,    96,
      97,    98,    99,    91,    92,    93,   100,   101,   172,   102,
     102,   387,   224,   221,   221,    88,   175,  -189,   283,   346,
     167,   279,   280,   281,   483,   413,   168,   207,   209,   313,
     198,   257,   198,   173,   510,   379,   282,   294,   376,    15,
      15,   290,   291,   173,   295,   295,    15,   162,   302,   106,
     182,   184,   303,   338,   120,    15,    85,    15,  -182,   353,
     225,   414,    15,   200,   354,    15,   108,   347,  -182,   102,
     431,   266,    91,   339,   185,    15,   191,   194,    15,   258,
     259,   507,   157,   102,   296,   102,  -196,   295,   265,    40,
     304,   305,    88,   223,   199,   159,    85,    85,   221,   221,
     221,   221,   221,   186,   187,   188,   201,   202,   203,   204,
     205,   258,   259,   165,   210,   211,   212,   213,   214,   215,
     265,   158,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   484,   274,   169,   405,   276,
      40,   442,   260,   306,   306,   406,    85,   267,   256,    85,
     361,   264,   363,   377,   268,   197,   295,   273,    76,   484,
     469,    76,   279,   280,   281,   266,   443,   444,   445,   446,
      40,   263,   364,   174,   366,    40,    40,   297,   298,   299,
     300,   301,     8,     9,   269,   443,   444,   445,   446,   170,
     195,   196,   275,   171,    16,    17,   271,   266,   175,   163,
     164,   284,   307,   285,   286,   390,   465,   466,   467,   468,
     277,   343,   345,   308,   397,   498,    15,   479,   306,   306,
     306,   306,   306,   420,   136,   137,   316,   138,   139,   140,
     141,   142,   143,   311,   331,   332,   317,   314,   417,  -196,
     419,   267,    15,   489,   318,   422,   423,   424,   438,    15,
     493,   102,   327,   323,   337,   325,    15,   514,   432,    15,
     517,   348,   433,   350,   329,   330,  -182,   371,   391,   134,
     340,   136,   137,   267,   138,   139,   140,   141,   142,   143,
      85,    85,   393,   456,   289,   395,   341,   402,   404,    40,
     407,   410,   427,   430,   349,   497,   355,   356,   357,   434,
     360,   463,   362,   464,   435,   365,    40,   436,    40,   118,
     369,   370,   505,   119,   439,   120,   374,   513,   375,   116,
     117,   118,   440,   454,   378,   119,   474,   120,   509,   521,
     380,   383,   105,   321,   388,   372,   373,   502,   453,    40,
     358,   426,   310,   452,   389,   396,   470,   471,    40,   127,
     128,   129,   130,   131,   132,   121,   122,   123,   124,   403,
     508,   127,   128,   129,   130,   131,   132,   523,   326,   511,
     472,   418,    40,   328,    40,   515,   421,   473,   518,    40,
      40,    40,   109,   110,     0,     0,   380,     0,     0,     0,
       0,     0,    40,     0,     0,     0,    40,     0,   181,   181,
       0,     0,   352,   441,     0,   134,   135,   136,   137,   359,
     138,   139,   140,   141,   142,   143,     0,    40,     0,   367,
     368,     0,   458,   459,   460,   461,   136,     0,     0,   138,
     139,   140,   141,   142,   143,    40,     0,    40,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,     0,     0,
       0,   392,     0,   394,     0,   480,     0,   490,   494,   398,
     399,     0,   272,     0,   400,   401,     2,     3,   501,     0,
       4,     0,     5,     0,     6,   512,   411,     7,   480,   412,
       0,   416,     0,   516,   490,   519,   494,   138,   139,   140,
     141,   142,   143,     0,     0,     0,   512,    10,   429,     0,
     522,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     437,     0,    11,    12,     0,     0,    13,    14,     0,    15,
       0,    16,    17,     0,     0,   455,     0,     0,   457,     0,
       0,     0,     0,     0,     0,     0,     0,   462,     0,     0,
       0,     0,     0,    31,     0,     0,     0,     0,     0,    32,
      33,     0,     0,     0,     0,   475,   476,   477,   478,   114,
     115,   116,   117,   118,     0,     0,     0,   119,     0,   120,
       0,   499,     0,     0,     1,     0,     0,   500,     2,     3,
       0,   504,     4,     0,     5,   506,     6,     0,     0,     7,
       8,     9,  -272,   144,     0,     0,     0,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    10,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,     0,     0,    11,    12,     0,     0,    13,    14,
       0,    15,     0,    16,    17,    18,    19,    20,    21,     0,
      22,     0,     0,    23,     0,     0,    24,    25,    26,    27,
       0,    28,     0,    29,    30,    31,     0,     0,     0,     0,
       0,    32,    33,     0,     0,     0,  -182,    34,  -272,  -201,
       2,     3,   322,     0,     4,     0,     5,     0,     6,     0,
       0,     7,   279,   280,   281,   324,     0,     0,     0,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,    10,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,     0,     0,    11,    12,     0,     0,
      13,    14,     0,    15,     0,    16,    17,    18,    19,    20,
      21,     0,    22,     0,     0,    23,     0,     0,    24,    25,
      26,    27,     0,    28,     0,    29,    30,    31,     0,     0,
       0,     2,     3,    32,    33,     4,     0,     5,  -182,     6,
       0,  -201,     7,   163,   164,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    10,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    11,    12,     0,
       0,    13,    14,     0,    15,     0,    16,    17,    18,    19,
      20,    21,     0,    22,     0,     0,    23,     0,     0,    24,
      25,    26,    27,     0,    28,     0,    29,    30,    31,     0,
       0,     0,     2,     3,    32,    33,     4,     0,     5,  -182,
       6,     0,  -201,     7,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    10,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    11,    12,
       0,     0,    13,    14,     0,    15,     0,    16,    17,    18,
      19,    20,    21,     0,    22,     0,     0,    23,     0,     0,
      24,    25,    26,    27,     0,    28,     0,    29,    30,    31,
     249,     0,     0,     2,     3,    32,    33,     4,     0,     5,
    -182,     6,     0,  -201,     7,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    10,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    11,
      12,     0,     0,    13,    14,     0,    15,     0,    16,    17,
      18,    19,    20,    21,     0,    22,     0,     0,    23,     0,
       0,    24,    25,    26,    27,     0,    28,     0,    29,    30,
      31,     0,     0,    77,     2,     3,    32,    33,     4,     0,
       5,  -182,     6,     0,  -201,     7,    78,    77,     2,     3,
       0,     0,     4,   206,     5,     0,     6,     0,     0,     7,
       0,     0,     0,     0,     0,    79,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
      11,    12,     0,     0,    13,    14,     0,    15,     0,    16,
      17,     0,     0,     0,    11,    12,     0,     0,    13,    14,
       0,    15,     0,    16,    17,     0,     0,     0,     0,     0,
       0,    31,     0,     0,    77,     2,     3,    32,    33,     4,
       0,     5,     0,     6,   208,    31,     7,     0,    77,     2,
       3,    32,    33,     4,   342,     5,     0,     6,     0,     0,
       7,     0,     0,     0,     0,     0,    79,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      79,    11,    12,     0,     0,    13,    14,     0,    15,     0,
      16,    17,     0,     0,     0,    11,    12,     0,     0,    13,
      14,     0,    15,     0,    16,    17,     0,     0,     0,     0,
       0,     0,    31,     0,     0,    77,     2,     3,    32,    33,
       4,     0,     5,     0,     6,   344,    31,     7,     0,    77,
       2,     3,    32,    33,     4,     0,     5,     0,     6,     0,
       0,     7,     0,     0,     0,     0,     0,    79,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    79,    11,    12,     0,     0,    13,    14,     0,    15,
       0,    16,    17,     0,     0,     0,    11,    12,     0,     0,
      13,    14,     0,    15,     0,    16,    17,     0,     0,     0,
       2,     3,     0,    31,     4,     0,     5,     0,     6,    32,
      33,     7,     2,     3,     0,     0,     4,    31,     5,     0,
       6,     0,     0,    32,    33,     0,     0,     0,     0,     0,
       0,    10,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    10,     0,     0,    11,    12,     0,     0,
      13,    14,     0,    15,     0,    16,    17,     0,    11,    12,
       0,     0,    13,    14,     0,    15,     0,    16,    17,     0,
       2,     3,     0,     0,   180,     0,     5,    31,     6,     0,
       0,     0,     0,    32,    33,     0,     0,     0,     0,    31,
       0,     0,     0,     0,     0,    32,    33,     0,     0,     0,
       0,    10,     0,     0,     0,     2,     3,     0,     0,   183,
       0,     5,     0,     6,     0,     0,    11,    12,     0,     0,
      13,    14,     0,    15,     0,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    10,     0,     0,     0,
     216,   217,     0,     0,     4,     0,     5,    31,     6,     0,
       0,    11,    12,    32,    33,    13,    14,     0,    15,     0,
      16,    17,     0,   113,   114,   115,   116,   117,   118,     0,
       0,   218,   119,     0,   120,     0,     0,     0,     0,     0,
       0,     0,    31,     0,     0,     0,   219,   220,    32,    33,
      13,    14,     0,    15,     0,    16,    17,     0,     0,     0,
       0,     0,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,     0,     0,     0,    31,     0,     0,
    -121,     0,     0,    32,    33,   293,   114,   115,   116,   117,
     118,     0,     0,     0,   119,     0,   120,  -121,  -121,  -121,
    -121,  -121,  -121,  -121,  -121,  -121,  -121,  -121,  -121,   134,
     135,   136,   137,     0,   138,   139,   140,   141,   142,   143,
       0,     0,     0,     0,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132
};

static const yytype_int16 yycheck[] =
{
       0,     7,     4,     5,     6,     0,   252,    78,   404,     6,
      19,    89,    40,    11,   169,     2,     3,    18,    19,    20,
      21,    22,    23,    10,    11,    12,    27,    28,     1,    29,
      30,   352,     9,   131,   132,     9,    89,    10,   191,     9,
      12,    17,    18,    19,    59,    59,    18,   118,   119,    12,
     103,    11,   105,    36,    59,    36,   190,    10,    10,    58,
      58,   195,   196,    36,    17,    17,    58,    68,     9,     0,
      94,    95,    13,    59,    15,    58,    78,    58,    93,    12,
      57,    95,    58,   111,    17,    58,    95,    57,    93,    89,
     411,   169,    79,    79,    96,    58,    98,    99,    58,    91,
      92,   497,    93,   103,    14,   105,     3,    17,   263,   109,
      51,    52,     9,   132,   109,    19,   118,   119,   216,   217,
     218,   219,   220,    17,    18,    19,   113,   114,   115,   116,
     117,    91,    92,    10,   121,   122,   123,   124,   125,   126,
     295,    96,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   476,   180,    17,    10,   183,
     160,    59,   162,   222,   223,    17,   168,   169,    19,   171,
     323,   168,   325,    14,   171,     3,    17,   179,   180,   500,
      59,   183,    17,    18,    19,   263,    84,    85,    86,    87,
     190,    17,   326,   271,   328,   195,   196,   216,   217,   218,
     219,   220,    17,    18,    10,    84,    85,    86,    87,    14,
     100,   101,     3,    18,    60,    61,    17,   295,   271,    17,
      18,    59,   224,    68,    69,   359,   458,   459,   460,   461,
       3,   302,   303,    95,   368,   481,    58,    59,   297,   298,
     299,   300,   301,   396,    34,    35,    15,    37,    38,    39,
      40,    41,    42,   254,    71,    72,    15,   257,   392,     3,
     394,   263,    58,    59,     3,   399,   400,   401,   421,    58,
      59,   271,    66,   275,    77,   277,    58,    59,   412,    58,
      59,    10,   416,     9,   285,   286,    93,    59,    10,    32,
     292,    34,    35,   295,    37,    38,    39,    40,    41,    42,
     302,   303,    17,   437,   194,    59,   293,    10,     3,   309,
      37,    95,    90,    34,   309,     3,   316,   317,   318,    59,
     322,   455,   324,   457,    10,   327,   326,    59,   328,     9,
     331,   332,     9,    13,    59,    15,   337,     3,   339,     7,
       8,     9,    59,    59,   346,    13,    59,    15,    59,    10,
     350,   351,    30,   271,   354,   334,   334,   488,   432,   359,
     318,   406,   252,   430,   358,   367,   462,   462,   368,    49,
      50,    51,    52,    53,    54,    43,    44,    45,    46,   379,
     498,    49,    50,    51,    52,    53,    54,   520,   278,   500,
     462,   393,   392,   283,   394,   504,   398,   462,   506,   399,
     400,   401,    37,    37,    -1,    -1,   406,    -1,    -1,    -1,
      -1,    -1,   412,    -1,    -1,    -1,   416,    -1,    94,    95,
      -1,    -1,   312,   425,    -1,    32,    33,    34,    35,   319,
      37,    38,    39,    40,    41,    42,    -1,   437,    -1,   329,
     330,    -1,   443,   444,   445,   446,    34,    -1,    -1,    37,
      38,    39,    40,    41,    42,   455,    -1,   457,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   361,    -1,   363,    -1,   475,    -1,   477,   478,   369,
     370,    -1,     1,    -1,   374,   375,     5,     6,   488,    -1,
       9,    -1,    11,    -1,    13,   501,   386,    16,   498,   389,
      -1,   391,    -1,   505,   504,   507,   506,    37,    38,    39,
      40,    41,    42,    -1,    -1,    -1,   522,    36,   408,    -1,
     520,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     420,    -1,    51,    52,    -1,    -1,    55,    56,    -1,    58,
      -1,    60,    61,    -1,    -1,   435,    -1,    -1,   438,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,    -1,    -1,
      -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,   465,   466,   467,   468,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    13,    -1,    15,
      -1,   481,    -1,    -1,     1,    -1,    -1,   487,     5,     6,
      -1,   491,     9,    -1,    11,   495,    13,    -1,    -1,    16,
      17,    18,    19,     3,    -1,    -1,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    36,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    51,    52,    -1,    -1,    55,    56,
      -1,    58,    -1,    60,    61,    62,    63,    64,    65,    -1,
      67,    -1,    -1,    70,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    -1,    80,    81,    82,    -1,    -1,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,    93,    94,    95,    96,
       5,     6,     3,    -1,     9,    -1,    11,    -1,    13,    -1,
      -1,    16,    17,    18,    19,     3,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    36,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    51,    52,    -1,    -1,
      55,    56,    -1,    58,    -1,    60,    61,    62,    63,    64,
      65,    -1,    67,    -1,    -1,    70,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    -1,    -1,
      -1,     5,     6,    88,    89,     9,    -1,    11,    93,    13,
      -1,    96,    16,    17,    18,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    -1,
      -1,    55,    56,    -1,    58,    -1,    60,    61,    62,    63,
      64,    65,    -1,    67,    -1,    -1,    70,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    -1,
      -1,    -1,     5,     6,    88,    89,     9,    -1,    11,    93,
      13,    -1,    96,    16,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      -1,    -1,    55,    56,    -1,    58,    -1,    60,    61,    62,
      63,    64,    65,    -1,    67,    -1,    -1,    70,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    -1,    80,    81,    82,
      83,    -1,    -1,     5,     6,    88,    89,     9,    -1,    11,
      93,    13,    -1,    96,    16,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      52,    -1,    -1,    55,    56,    -1,    58,    -1,    60,    61,
      62,    63,    64,    65,    -1,    67,    -1,    -1,    70,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    -1,    -1,     4,     5,     6,    88,    89,     9,    -1,
      11,    93,    13,    -1,    96,    16,    17,     4,     5,     6,
      -1,    -1,     9,    10,    11,    -1,    13,    -1,    -1,    16,
      -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,
      51,    52,    -1,    -1,    55,    56,    -1,    58,    -1,    60,
      61,    -1,    -1,    -1,    51,    52,    -1,    -1,    55,    56,
      -1,    58,    -1,    60,    61,    -1,    -1,    -1,    -1,    -1,
      -1,    82,    -1,    -1,     4,     5,     6,    88,    89,     9,
      -1,    11,    -1,    13,    14,    82,    16,    -1,     4,     5,
       6,    88,    89,     9,    10,    11,    -1,    13,    -1,    -1,
      16,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      36,    51,    52,    -1,    -1,    55,    56,    -1,    58,    -1,
      60,    61,    -1,    -1,    -1,    51,    52,    -1,    -1,    55,
      56,    -1,    58,    -1,    60,    61,    -1,    -1,    -1,    -1,
      -1,    -1,    82,    -1,    -1,     4,     5,     6,    88,    89,
       9,    -1,    11,    -1,    13,    14,    82,    16,    -1,     4,
       5,     6,    88,    89,     9,    -1,    11,    -1,    13,    -1,
      -1,    16,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    36,    51,    52,    -1,    -1,    55,    56,    -1,    58,
      -1,    60,    61,    -1,    -1,    -1,    51,    52,    -1,    -1,
      55,    56,    -1,    58,    -1,    60,    61,    -1,    -1,    -1,
       5,     6,    -1,    82,     9,    -1,    11,    -1,    13,    88,
      89,    16,     5,     6,    -1,    -1,     9,    82,    11,    -1,
      13,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    51,    52,    -1,    -1,
      55,    56,    -1,    58,    -1,    60,    61,    -1,    51,    52,
      -1,    -1,    55,    56,    -1,    58,    -1,    60,    61,    -1,
       5,     6,    -1,    -1,     9,    -1,    11,    82,    13,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    82,
      -1,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,     5,     6,    -1,    -1,     9,
      -1,    11,    -1,    13,    -1,    -1,    51,    52,    -1,    -1,
      55,    56,    -1,    58,    -1,    60,    61,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
       5,     6,    -1,    -1,     9,    -1,    11,    82,    13,    -1,
      -1,    51,    52,    88,    89,    55,    56,    -1,    58,    -1,
      60,    61,    -1,     4,     5,     6,     7,     8,     9,    -1,
      -1,    36,    13,    -1,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    82,    -1,    -1,    -1,    51,    52,    88,    89,
      55,    56,    -1,    58,    -1,    60,    61,    -1,    -1,    -1,
      -1,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    82,    -1,    -1,
       3,    -1,    -1,    88,    89,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    13,    -1,    15,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      -1,    -1,    -1,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     5,     6,     9,    11,    13,    16,    17,    18,
      36,    51,    52,    55,    56,    58,    60,    61,    62,    63,
      64,    65,    67,    70,    73,    74,    75,    76,    78,    80,
      81,    82,    88,    89,    94,    99,   100,   101,   108,   109,
     111,   112,   113,   114,   115,   116,   118,   121,   122,   123,
     128,   130,   131,   132,   133,   134,   135,   136,   140,   141,
     146,   151,   152,   153,   154,   165,   166,   167,   168,   171,
     199,   200,   201,   111,   128,   128,   134,     4,    17,    36,
     117,   120,   124,   125,   126,   134,   119,   120,     9,   155,
     158,   128,   128,   128,   198,   198,   198,   198,   198,   198,
     198,   198,   111,   137,   139,   137,     0,    19,    95,   200,
     201,   110,   114,     4,     5,     6,     7,     8,     9,    13,
      15,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,   127,    32,    33,    34,    35,    37,    38,
      39,    40,    41,    42,     3,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    93,    96,    19,
     202,   203,   198,    17,    18,    10,   126,    12,    18,    17,
      14,    18,     1,    36,   125,   139,   159,   160,   161,   197,
       9,   131,   132,     9,   132,   134,    17,    18,    19,   204,
     205,   134,   142,   143,   134,   205,   205,     3,   139,   108,
     114,   128,   128,   128,   128,   128,    10,   126,    14,   126,
     128,   128,   128,   128,   128,   128,     5,     6,    36,    51,
      52,   123,   129,   129,     9,    57,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   134,   134,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,    83,
     102,   103,   104,   108,   172,   173,    19,    11,    91,    92,
     111,   162,   169,    17,   120,   124,   125,   134,   120,    10,
     156,    17,     1,   134,   132,     3,   132,     3,   196,    17,
      18,    19,   102,   196,    59,    68,    69,   144,   145,   205,
     102,   102,   138,     4,    10,    17,    14,   129,   129,   129,
     129,   129,     9,    13,    51,    52,   127,   134,    95,   204,
     205,   198,   164,    12,   111,   163,    15,    15,     3,   157,
     158,   161,     3,   134,     3,   134,   205,    66,   205,   198,
     198,    71,    72,   147,   148,   149,   150,    77,    59,    79,
     134,   128,    10,   126,    14,   126,     9,    57,    10,   108,
       9,   174,   205,    12,    17,   111,   111,   111,   169,   205,
     134,   196,   134,   196,   102,   134,   102,   205,   205,   198,
     198,    59,   149,   150,   198,   198,    10,    14,   134,    36,
     111,   175,   176,   111,   105,   106,   107,   171,   111,   157,
     102,    10,   205,    17,   205,    59,   134,   102,   205,   205,
     205,   205,    10,   111,     3,    10,    17,    37,   177,   178,
      95,   205,   205,    59,    95,   170,   205,   102,   134,   102,
     196,   134,   102,   102,   102,   138,   176,    90,   179,   205,
      34,   171,   102,   102,    59,    10,    59,   205,   196,    59,
      59,   134,    59,    84,    85,    86,    87,   180,   181,   184,
     190,   193,   179,   170,    59,   205,   102,   205,   198,   198,
     198,   198,   205,   102,   102,   174,   174,   174,   174,    59,
     181,   184,   190,   193,    59,   205,   205,   205,   205,    59,
     111,   182,   183,    59,   171,   186,   188,   189,   198,    59,
     111,   191,   192,    59,   111,   194,   195,     3,   204,   205,
     205,   111,   162,   185,   205,     9,   205,   138,   183,    59,
      59,   188,   158,     3,    59,   192,   134,    59,   195,   134,
     187,    10,   111,   185
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    98,    99,    99,    99,   100,   100,   101,   101,   102,
     102,   103,   104,   104,   105,   105,   106,   107,   107,   108,
     108,   108,   109,   110,   110,   111,   112,   113,   114,   114,
     115,   115,   115,   116,   117,   117,   118,   119,   119,   120,
     120,   120,   120,   120,   120,   121,   122,   122,   123,   123,
     123,   123,   123,   123,   123,   123,   124,   125,   126,   126,
     126,   126,   126,   126,   127,   128,   128,   128,   128,   128,
     128,   128,   128,   128,   128,   128,   128,   128,   128,   128,
     128,   128,   128,   128,   128,   128,   128,   128,   128,   128,
     128,   128,   128,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   130,   130,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     131,   132,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   134,   134,   134,   135,   135,
     135,   135,   135,   135,   135,   136,   136,   137,   137,   138,
     139,   139,   140,   140,   141,   142,   142,   143,   143,   144,
     145,   146,   147,   147,   147,   147,   148,   148,   149,   150,
     151,   151,   151,   151,   151,   151,   152,   152,   152,   153,
     153,   153,   154,   155,   156,   157,   157,   158,   158,   159,
     159,   160,   160,   161,   161,   162,   162,   162,   163,   163,
     164,   165,   166,   167,   167,   168,   169,   169,   169,   170,
     170,   171,   171,   172,   173,   173,   174,   174,   175,   175,
     176,   176,   176,   177,   177,   178,   178,   179,   180,   180,
     180,   180,   180,   180,   180,   180,   181,   181,   182,   182,
     183,   183,   184,   184,   185,   185,   186,   187,   186,   188,
     188,   189,   189,   190,   190,   191,   191,   192,   193,   193,
     194,   194,   195,   196,   197,   198,   199,   199,   200,   200,
     200,   200,   201,   201,   202,   202,   203,   203,   204,   204,
     204,   204,   204,   204,   205,   205
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     2,     1,     1,     2,     1,     3,     0,
       1,     2,     1,     3,     0,     1,     2,     1,     3,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     3,     1,     3,     0,
       1,     1,     2,     2,     3,     1,     4,     4,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     3,     3,     3,     1,     1,     2,     2,     3,     4,
       3,     4,     2,     2,     3,     5,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     2,     2,     3,     4,     3,     4,
       3,     5,     2,     2,     2,     2,     2,     3,     5,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     2,     0,
       1,     4,     1,     1,     4,     1,     2,     4,     2,     7,
       4,     6,     0,     1,     1,     2,     1,     2,     7,     4,
       7,     6,     9,    10,     9,    12,     1,     1,     1,     9,
       9,     5,     0,     1,     1,     0,     1,     3,     2,     0,
       1,     1,     3,     1,     1,     2,     1,     3,     1,     3,
       0,     0,     2,     4,     7,     2,     1,     3,     3,     1,
       1,     7,     9,     1,     9,     7,     0,     3,     1,     3,
       1,     4,     2,     0,     1,     2,     3,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     7,     5,     1,     3,
       1,     4,     7,     5,     1,     2,     2,     0,     5,     1,
       1,     1,     3,     7,     5,     1,     3,     1,     7,     5,
       1,     3,     4,     0,     0,     0,     1,     1,     1,     1,
       2,     2,     0,     1,     0,     1,     1,     2,     1,     1,
       1,     2,     2,     2,     0,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (parser, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if OCTAVE_DEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, parser); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, octave::base_parser& parser)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (parser);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, octave::base_parser& parser)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep, parser);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, int yyrule, octave::base_parser& parser)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[+yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              , parser);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, parser); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !OCTAVE_DEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !OCTAVE_DEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[+*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, octave::base_parser& parser)
{
  YYUSE (yyvaluep);
  YYUSE (parser);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yytype)
    {
    case 3: /* '='  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 1944 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 4: /* ':'  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 1950 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 5: /* '-'  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 1956 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 6: /* '+'  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 1962 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 7: /* '*'  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 1968 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 8: /* '/'  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 1974 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 9: /* '('  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 1980 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 10: /* ')'  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 1986 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 11: /* '['  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 1992 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 12: /* ']'  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 1998 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 13: /* '{'  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2004 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 14: /* '}'  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2010 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 15: /* '.'  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2016 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 16: /* '@'  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2022 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 17: /* ','  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2028 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 18: /* ';'  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2034 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 19: /* '\n'  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2040 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 20: /* ADD_EQ  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2046 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 21: /* SUB_EQ  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2052 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 22: /* MUL_EQ  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2058 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 23: /* DIV_EQ  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2064 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 24: /* LEFTDIV_EQ  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2070 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 25: /* POW_EQ  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2076 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 26: /* EMUL_EQ  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2082 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 27: /* EDIV_EQ  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2088 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 28: /* ELEFTDIV_EQ  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2094 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 29: /* EPOW_EQ  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2100 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 30: /* AND_EQ  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2106 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 31: /* OR_EQ  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2112 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 32: /* EXPR_AND_AND  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2118 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 33: /* EXPR_OR_OR  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2124 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 34: /* EXPR_AND  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2130 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 35: /* EXPR_OR  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2136 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 36: /* EXPR_NOT  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2142 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 37: /* EXPR_LT  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2148 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 38: /* EXPR_LE  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2154 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 39: /* EXPR_EQ  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2160 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 40: /* EXPR_NE  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2166 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 41: /* EXPR_GE  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2172 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 42: /* EXPR_GT  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2178 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 43: /* LEFTDIV  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2184 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 44: /* EMUL  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2190 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 45: /* EDIV  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2196 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 46: /* ELEFTDIV  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2202 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 47: /* EPLUS  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2208 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 48: /* EMINUS  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2214 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 49: /* HERMITIAN  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2220 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 50: /* TRANSPOSE  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2226 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 51: /* PLUS_PLUS  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2232 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 52: /* MINUS_MINUS  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2238 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 53: /* POW  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2244 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 54: /* EPOW  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2250 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 55: /* NUM  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2256 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 56: /* IMAG_NUM  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2262 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 57: /* STRUCT_ELT  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2268 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 58: /* NAME  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2274 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 59: /* END  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2280 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 60: /* DQ_STRING  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2286 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 61: /* SQ_STRING  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2292 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 62: /* FOR  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2298 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 63: /* PARFOR  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2304 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 64: /* WHILE  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2310 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 65: /* DO  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2316 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 66: /* UNTIL  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2322 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 67: /* IF  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2328 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 68: /* ELSEIF  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2334 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 69: /* ELSE  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2340 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 70: /* SWITCH  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2346 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 71: /* CASE  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2352 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 72: /* OTHERWISE  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2358 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 73: /* BREAK  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2364 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 74: /* CONTINUE  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2370 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 75: /* FUNC_RET  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2376 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 76: /* UNWIND  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2382 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 77: /* CLEANUP  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2388 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 78: /* TRY  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2394 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 79: /* CATCH  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2400 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 80: /* GLOBAL  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2406 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 81: /* PERSISTENT  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2412 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 82: /* FCN_HANDLE  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2418 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 83: /* CLASSDEF  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2424 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 84: /* PROPERTIES  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2430 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 85: /* METHODS  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2436 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 86: /* EVENTS  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2442 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 87: /* ENUMERATION  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2448 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 88: /* METAQUERY  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2454 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 89: /* SUPERCLASSREF  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2460 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 90: /* FQ_IDENT  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2466 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 91: /* GET  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2472 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 92: /* SET  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2478 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 93: /* FCN  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2484 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 94: /* LEXICAL_ERROR  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2490 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 95: /* END_OF_INPUT  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2496 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 97: /* UNARY  */
#line 317 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2502 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 99: /* input  */
#line 319 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_type); }
#line 2508 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 100: /* simple_list  */
#line 344 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2514 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 101: /* simple_list1  */
#line 344 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2520 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 102: /* opt_list  */
#line 344 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2526 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 103: /* list  */
#line 344 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2532 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 104: /* list1  */
#line 344 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2538 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 105: /* opt_fcn_list  */
#line 344 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2544 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 106: /* fcn_list  */
#line 344 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2550 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 107: /* fcn_list1  */
#line 344 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2556 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 108: /* statement  */
#line 343 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_type); }
#line 2562 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 109: /* word_list_cmd  */
#line 330 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_index_expression_type); }
#line 2568 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 110: /* word_list  */
#line 331 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_argument_list_type); }
#line 2574 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 111: /* identifier  */
#line 329 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_identifier_type); }
#line 2580 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 112: /* superclass_identifier  */
#line 325 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_superclass_ref_type); }
#line 2586 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 113: /* meta_identifier  */
#line 326 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_metaclass_query_type); }
#line 2592 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 114: /* string  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_constant_type); }
#line 2598 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 115: /* constant  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_constant_type); }
#line 2604 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 116: /* matrix  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2610 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 117: /* matrix_rows  */
#line 320 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_matrix_type); }
#line 2616 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 118: /* cell  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2622 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 119: /* cell_rows  */
#line 321 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_cell_type); }
#line 2628 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 120: /* cell_or_matrix_row  */
#line 331 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_argument_list_type); }
#line 2634 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 121: /* fcn_handle  */
#line 324 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_fcn_handle_type); }
#line 2640 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 122: /* anon_fcn_handle  */
#line 328 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_anon_fcn_handle_type); }
#line 2646 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 123: /* primary_expr  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2652 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 124: /* magic_colon  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_constant_type); }
#line 2658 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 125: /* magic_tilde  */
#line 329 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_identifier_type); }
#line 2664 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 126: /* arg_list  */
#line 331 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_argument_list_type); }
#line 2670 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 128: /* oper_expr  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2676 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 129: /* power_expr  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2682 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 130: /* colon_expr  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2688 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 131: /* simple_expr  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2694 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 132: /* assign_lhs  */
#line 331 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_argument_list_type); }
#line 2700 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 133: /* assign_expr  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2706 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 134: /* expression  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2712 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 135: /* command  */
#line 333 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2718 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 136: /* declaration  */
#line 342 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_decl_command_type); }
#line 2724 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 137: /* decl1  */
#line 341 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_decl_init_list_type); }
#line 2730 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 139: /* decl2  */
#line 340 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_decl_elt_type); }
#line 2736 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 140: /* select_command  */
#line 333 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2742 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 141: /* if_command  */
#line 334 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_command_type); }
#line 2748 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 142: /* if_cmd_list  */
#line 336 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_command_list_type); }
#line 2754 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 143: /* if_cmd_list1  */
#line 336 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_command_list_type); }
#line 2760 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 144: /* elseif_clause  */
#line 335 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_clause_type); }
#line 2766 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 145: /* else_clause  */
#line 335 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_clause_type); }
#line 2772 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 146: /* switch_command  */
#line 337 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_command_type); }
#line 2778 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 147: /* case_list  */
#line 339 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_case_list_type); }
#line 2784 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 148: /* case_list1  */
#line 339 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_case_list_type); }
#line 2790 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 149: /* switch_case  */
#line 338 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_case_type); }
#line 2796 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 150: /* default_case  */
#line 338 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_case_type); }
#line 2802 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 151: /* loop_command  */
#line 333 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2808 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 152: /* jump_command  */
#line 333 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2814 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 153: /* except_command  */
#line 333 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2820 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 157: /* opt_param_list  */
#line 332 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2826 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 158: /* param_list  */
#line 332 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2832 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 159: /* param_list1  */
#line 332 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2838 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 160: /* param_list2  */
#line 332 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2844 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 161: /* param_list_elt  */
#line 340 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_decl_elt_type); }
#line 2850 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 162: /* return_list  */
#line 332 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2856 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 163: /* return_list1  */
#line 332 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2862 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 167: /* file  */
#line 333 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2868 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 168: /* function_beg  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2874 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 169: /* fcn_name  */
#line 329 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_identifier_type); }
#line 2880 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 170: /* function_end  */
#line 343 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_type); }
#line 2886 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 171: /* function  */
#line 327 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_function_def_type); }
#line 2892 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 172: /* classdef_beg  */
#line 314 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2898 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 173: /* classdef  */
#line 347 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_type); }
#line 2904 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 174: /* opt_attr_list  */
#line 349 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_attribute_list_type); }
#line 2910 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 175: /* attr_list  */
#line 349 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_attribute_list_type); }
#line 2916 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 176: /* attr  */
#line 348 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_attribute_type); }
#line 2922 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 177: /* opt_superclass_list  */
#line 351 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_superclass_list_type); }
#line 2928 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 178: /* superclass_list  */
#line 351 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_superclass_list_type); }
#line 2934 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 179: /* superclass  */
#line 350 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_superclass_type); }
#line 2940 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 180: /* class_body  */
#line 352 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_body_type); }
#line 2946 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 181: /* properties_block  */
#line 355 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_properties_block_type); }
#line 2952 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 182: /* property_list  */
#line 354 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_property_list_type); }
#line 2958 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 183: /* class_property  */
#line 353 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_property_type); }
#line 2964 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 184: /* methods_block  */
#line 357 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_methods_block_type); }
#line 2970 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 185: /* method_decl1  */
#line 345 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).octave_user_function_type); }
#line 2976 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 186: /* method_decl  */
#line 327 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_function_def_type); }
#line 2982 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 188: /* method  */
#line 327 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_function_def_type); }
#line 2988 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 189: /* methods_list  */
#line 356 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_methods_list_type); }
#line 2994 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 190: /* events_block  */
#line 360 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_events_block_type); }
#line 3000 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 191: /* events_list  */
#line 359 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_events_list_type); }
#line 3006 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 192: /* class_event  */
#line 358 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_event_type); }
#line 3012 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 193: /* enum_block  */
#line 363 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_enum_block_type); }
#line 3018 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 194: /* enum_list  */
#line 362 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_enum_list_type); }
#line 3024 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 195: /* class_enum  */
#line 361 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_enum_type); }
#line 3030 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 198: /* stash_comment  */
#line 316 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3036 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 200: /* sep_no_nl  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3042 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 201: /* opt_sep_no_nl  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3048 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 202: /* opt_nl  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3054 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 203: /* nl  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3060 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 204: /* sep  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3066 "libinterp/parse-tree/oct-parse.cc"
        break;

    case 205: /* opt_sep  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3072 "libinterp/parse-tree/oct-parse.cc"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}



struct yypstate
  {
    /* Number of syntax errors so far.  */
    int yynerrs;

    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYPTRDIFF_T yystacksize;
    /* Used to determine if this is the first time this instance has
       been used.  */
    int yynew;
  };

int
yyparse (octave::base_parser& parser)
{
  return yypull_parse (YY_NULLPTR, parser);
}

int
yypull_parse (yypstate *yyps, octave::base_parser& parser)
{
  yypstate *yyps_local;
  if (yyps)
    yyps_local = yyps;
  else
    {
      yyps_local = yypstate_new ();
      if (!yyps_local)
        {
          yyerror (parser, YY_("memory exhausted"));
          return 2;
        }
    }
  int yystatus;
  do {
    YYSTYPE yylval;
    int yychar = yylex (&yylval, scanner);
    yystatus =
      yypush_parse (yyps_local, yychar, &yylval, parser);
  } while (yystatus == YYPUSH_MORE);
  if (!yyps)
    yypstate_delete (yyps_local);
  return yystatus;
}

/* Initialize the parser data structure.  */
yypstate *
yypstate_new (void)
{
  yypstate *yyps;
  yyps = YY_CAST (yypstate *, malloc (sizeof *yyps));
  if (!yyps)
    return YY_NULLPTR;
  yyps->yynew = 1;
  return yyps;
}

void
yypstate_delete (yypstate *yyps)
{
  if (yyps)
    {
#ifndef yyoverflow
      /* If the stack was reallocated but the parse did not complete, then the
         stack still needs to be freed.  */
      if (!yyps->yynew && yyps->yyss != yyps->yyssa)
        YYSTACK_FREE (yyps->yyss);
#endif
      free (yyps);
    }
}

#define octave_nerrs yyps->octave_nerrs
#define yystate yyps->yystate
#define yyerrstatus yyps->yyerrstatus
#define yyssa yyps->yyssa
#define yyss yyps->yyss
#define yyssp yyps->yyssp
#define yyvsa yyps->yyvsa
#define yyvs yyps->yyvs
#define yyvsp yyps->yyvsp
#define yystacksize yyps->yystacksize


/*---------------.
| yypush_parse.  |
`---------------*/

int
yypush_parse (yypstate *yyps, int yypushed_char, YYSTYPE const *yypushed_val, octave::base_parser& parser)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  if (!yyps->yynew)
    {
      yyn = yypact[yystate];
      goto yyread_pushed_token;
    }

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      if (!yyps->yynew)
        {
          YYDPRINTF ((stderr, "Return for a new token:\n"));
          yyresult = YYPUSH_MORE;
          goto yypushreturn;
        }
      yyps->yynew = 0;
yyread_pushed_token:
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yypushed_char;
      if (yypushed_val)
        yylval = *yypushed_val;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2:
#line 384 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_type) = nullptr;
                    parser.statement_list (std::shared_ptr<octave::tree_statement_list> ((yyvsp[-1].tree_statement_list_type)));
                    YYACCEPT;
                  }
#line 3445 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 3:
#line 392 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_type) = nullptr;
                    lexer.m_end_of_input = true;
                    parser.statement_list (std::shared_ptr<octave::tree_statement_list> ((yyvsp[-1].tree_statement_list_type)));
                    YYACCEPT;
                  }
#line 3458 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 4:
#line 401 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_type) = nullptr;
                    YYABORT;
                  }
#line 3467 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 5:
#line 408 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_statement_list_type) = nullptr;
                  }
#line 3477 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 6:
#line 414 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.set_stmt_print_flag ((yyvsp[-1].tree_statement_list_type), (yyvsp[0].punct_type), false); }
#line 3483 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 7:
#line 418 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.make_statement_list ((yyvsp[0].tree_statement_type)); }
#line 3489 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 8:
#line 420 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.append_statement_list ((yyvsp[-2].tree_statement_list_type), (yyvsp[-1].punct_type), (yyvsp[0].tree_statement_type), false); }
#line 3495 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 9:
#line 424 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = new octave::tree_statement_list (); }
#line 3501 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 10:
#line 426 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = (yyvsp[0].tree_statement_list_type); }
#line 3507 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 11:
#line 430 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.set_stmt_print_flag ((yyvsp[-1].tree_statement_list_type), (yyvsp[0].punct_type), true); }
#line 3513 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 12:
#line 434 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.make_statement_list ((yyvsp[0].tree_statement_type)); }
#line 3519 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 13:
#line 436 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.append_statement_list ((yyvsp[-2].tree_statement_list_type), (yyvsp[-1].punct_type), (yyvsp[0].tree_statement_type), true); }
#line 3525 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 14:
#line 440 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = new octave::tree_statement_list (); }
#line 3531 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 15:
#line 442 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = (yyvsp[0].tree_statement_list_type); }
#line 3537 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 16:
#line 446 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_statement_list_type) = (yyvsp[-1].tree_statement_list_type);
                  }
#line 3547 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 17:
#line 454 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    octave::tree_statement *stmt = parser.make_statement ((yyvsp[0].tree_function_def_type));
                    (yyval.tree_statement_list_type) = new octave::tree_statement_list (stmt);
                  }
#line 3556 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 18:
#line 459 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    octave::tree_statement *stmt = parser.make_statement ((yyvsp[0].tree_function_def_type));
                    (yyval.tree_statement_list_type) = parser.append_statement_list ((yyvsp[-2].tree_statement_list_type), (yyvsp[-1].punct_type), stmt, false);
                  }
#line 3565 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 19:
#line 466 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_type) = parser.make_statement ((yyvsp[0].tree_expression_type)); }
#line 3571 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 20:
#line 468 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_type) = parser.make_statement ((yyvsp[0].tree_command_type)); }
#line 3577 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 21:
#line 470 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_type) = parser.make_statement ((yyvsp[0].tree_index_expression_type)); }
#line 3583 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 22:
#line 482 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_index_expression_type) = parser.make_index_expression ((yyvsp[-1].tree_identifier_type), (yyvsp[0].tree_argument_list_type), '(');
                    if (! (yyval.tree_index_expression_type))
                      {
                        // make_index_expression deleted $1 and $2.
                        YYABORT;
                      }
                    (yyval.tree_index_expression_type)->mark_word_list_cmd ();
                  }
#line 3597 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 23:
#line 494 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = new octave::tree_argument_list ((yyvsp[0].tree_constant_type)); }
#line 3603 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 24:
#line 496 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_argument_list_type)->append ((yyvsp[0].tree_constant_type));
                    (yyval.tree_argument_list_type) = (yyvsp[-1].tree_argument_list_type);
                  }
#line 3612 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 25:
#line 507 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_identifier_type) = new octave::tree_identifier ((yyvsp[0].tok_val)->sym_rec (),
                                                      (yyvsp[0].tok_val)->line (),
                                                      (yyvsp[0].tok_val)->column ());
                  }
#line 3622 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 26:
#line 516 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    std::string meth = (yyvsp[0].tok_val)->superclass_method_name ();
                    std::string cls = (yyvsp[0].tok_val)->superclass_class_name ();

                    (yyval.tree_superclass_ref_type) = new octave::tree_superclass_ref (meth, cls,
                                                          (yyvsp[0].tok_val)->line (),
                                                          (yyvsp[0].tok_val)->column ());
                  }
#line 3635 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 27:
#line 527 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    std::string cls = (yyvsp[0].tok_val)->text ();

                    (yyval.tree_metaclass_query_type) = new octave::tree_metaclass_query (cls, (yyvsp[0].tok_val)->line (),
                                                           (yyvsp[0].tok_val)->column ());
                  }
#line 3646 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 28:
#line 536 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = parser.make_constant (DQ_STRING, (yyvsp[0].tok_val)); }
#line 3652 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 29:
#line 538 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = parser.make_constant (SQ_STRING, (yyvsp[0].tok_val)); }
#line 3658 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 30:
#line 542 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = parser.make_constant (NUM, (yyvsp[0].tok_val)); }
#line 3664 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 31:
#line 544 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = parser.make_constant (IMAG_NUM, (yyvsp[0].tok_val)); }
#line 3670 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 32:
#line 546 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = (yyvsp[0].tree_constant_type); }
#line 3676 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 33:
#line 550 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.finish_matrix ((yyvsp[-1].tree_matrix_type), (yyvsp[-2].tok_val), (yyvsp[0].tok_val)); }
#line 3682 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 34:
#line 554 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_matrix_type) = (yyvsp[0].tree_argument_list_type) ? new octave::tree_matrix ((yyvsp[0].tree_argument_list_type)) : nullptr; }
#line 3688 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 35:
#line 556 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    if ((yyvsp[-2].tree_matrix_type))
                      {
                        if ((yyvsp[0].tree_argument_list_type))
                          (yyvsp[-2].tree_matrix_type)->append ((yyvsp[0].tree_argument_list_type));

                        (yyval.tree_matrix_type) = (yyvsp[-2].tree_matrix_type);
                      }
                    else
                      (yyval.tree_matrix_type) = (yyvsp[0].tree_argument_list_type) ? new octave::tree_matrix ((yyvsp[0].tree_argument_list_type)) : nullptr;
                  }
#line 3706 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 36:
#line 572 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.finish_cell ((yyvsp[-1].tree_cell_type), (yyvsp[-2].tok_val), (yyvsp[0].tok_val)); }
#line 3712 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 37:
#line 576 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_cell_type) = (yyvsp[0].tree_argument_list_type) ? new octave::tree_cell ((yyvsp[0].tree_argument_list_type)) : nullptr; }
#line 3718 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 38:
#line 578 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    if ((yyvsp[-2].tree_cell_type))
                      {
                        if ((yyvsp[0].tree_argument_list_type))
                          (yyvsp[-2].tree_cell_type)->append ((yyvsp[0].tree_argument_list_type));

                        (yyval.tree_cell_type) = (yyvsp[-2].tree_cell_type);
                      }
                    else
                      (yyval.tree_cell_type) = (yyvsp[0].tree_argument_list_type) ? new octave::tree_cell ((yyvsp[0].tree_argument_list_type)) : nullptr;
                  }
#line 3736 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 39:
#line 598 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = nullptr; }
#line 3742 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 40:
#line 600 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_argument_list_type) = nullptr;
                  }
#line 3752 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 41:
#line 606 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = (yyvsp[0].tree_argument_list_type); }
#line 3758 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 42:
#line 608 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_argument_list_type) = (yyvsp[-1].tree_argument_list_type);
                  }
#line 3768 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 43:
#line 614 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_argument_list_type) = (yyvsp[0].tree_argument_list_type);
                  }
#line 3778 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 44:
#line 620 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_argument_list_type) = (yyvsp[-1].tree_argument_list_type);
                  }
#line 3789 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 45:
#line 629 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_fcn_handle_type) = parser.make_fcn_handle ((yyvsp[0].tok_val)); }
#line 3795 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 46:
#line 637 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_anon_fcn_handle_type) = parser.make_anon_fcn_handle ((yyvsp[-2].tree_parameter_list_type), (yyvsp[0].tree_expression_type), (yyvsp[-3].tok_val)->beg_pos ());
                    if (! (yyval.tree_anon_fcn_handle_type))
                      {
                        // make_anon_fcn_handle deleted $2 and $4.
                        YYABORT;
                      }

                    lexer.m_parsing_anon_fcn_body = false;
                    lexer.m_nesting_level.remove ();
                  }
#line 3811 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 47:
#line 649 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].tok_val));
                    YYUSE ((yyvsp[-2].tree_parameter_list_type));

                    lexer.m_parsing_anon_fcn_body = false;

                    (yyval.tree_anon_fcn_handle_type) = nullptr;
                    parser.bison_error ("anonymous function bodies must be single expressions");
                    YYABORT;
                  }
#line 3826 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 48:
#line 662 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_identifier_type); }
#line 3832 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 49:
#line 664 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_constant_type); }
#line 3838 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 50:
#line 666 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_fcn_handle_type); }
#line 3844 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 51:
#line 668 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    lexer.m_looking_at_matrix_or_assign_lhs = false;
                    (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type);
                  }
#line 3853 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 52:
#line 673 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 3859 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 53:
#line 675 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_metaclass_query_type); }
#line 3865 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 54:
#line 677 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_superclass_ref_type); }
#line 3871 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 55:
#line 679 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = (yyvsp[-1].tree_expression_type)->mark_in_parens ();
                  }
#line 3882 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 56:
#line 688 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    octave_value tmp (octave_value::magic_colon_t);
                    (yyval.tree_constant_type) = new octave::tree_constant (tmp);
                  }
#line 3893 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 57:
#line 697 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_identifier_type) = new octave::tree_black_hole ();
                  }
#line 3903 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 58:
#line 705 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = new octave::tree_argument_list ((yyvsp[0].tree_expression_type)); }
#line 3909 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 59:
#line 707 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = new octave::tree_argument_list ((yyvsp[0].tree_constant_type)); }
#line 3915 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 60:
#line 709 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = new octave::tree_argument_list ((yyvsp[0].tree_identifier_type)); }
#line 3921 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 61:
#line 711 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_argument_list_type)->append ((yyvsp[0].tree_constant_type));
                    (yyval.tree_argument_list_type) = (yyvsp[-2].tree_argument_list_type);
                  }
#line 3932 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 62:
#line 718 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_argument_list_type)->append ((yyvsp[0].tree_identifier_type));
                    (yyval.tree_argument_list_type) = (yyvsp[-2].tree_argument_list_type);
                  }
#line 3943 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 63:
#line 725 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_argument_list_type)->append ((yyvsp[0].tree_expression_type));
                    (yyval.tree_argument_list_type) = (yyvsp[-2].tree_argument_list_type);
                  }
#line 3954 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 64:
#line 734 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.dummy_type) = 0;
                    lexer.m_looking_at_indirect_ref = true;
                  }
#line 3965 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 65:
#line 743 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 3971 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 66:
#line 745 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (PLUS_PLUS, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 3977 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 67:
#line 747 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (MINUS_MINUS, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 3983 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 68:
#line 749 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-2].tree_expression_type), nullptr, '(');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1.
                        YYABORT;
                      }
                  }
#line 3999 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 69:
#line 761 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_argument_list_type), '(');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4015 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 70:
#line 773 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-2].tree_expression_type), nullptr, '{');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1.
                        YYABORT;
                      }
                  }
#line 4031 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 71:
#line 785 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_argument_list_type), '{');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4047 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 72:
#line 797 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (HERMITIAN, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4053 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 73:
#line 799 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (TRANSPOSE, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4059 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 74:
#line 801 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_indirect_ref ((yyvsp[-2].tree_expression_type), (yyvsp[0].tok_val)->text ()); }
#line 4065 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 75:
#line 803 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_indirect_ref ((yyvsp[-4].tree_expression_type), (yyvsp[-1].tree_expression_type));
                  }
#line 4076 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 76:
#line 810 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (PLUS_PLUS, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4082 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 77:
#line 812 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (MINUS_MINUS, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4088 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 78:
#line 814 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (EXPR_NOT, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4094 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 79:
#line 816 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op ('+', (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4100 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 80:
#line 818 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op ('-', (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4106 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 81:
#line 820 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (POW, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4112 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 82:
#line 822 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EPOW, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4118 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 83:
#line 824 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('+', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4124 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 84:
#line 826 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('-', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4130 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 85:
#line 828 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('*', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4136 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 86:
#line 830 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('/', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4142 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 87:
#line 832 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('+', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4148 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 88:
#line 834 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('-', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4154 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 89:
#line 836 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EMUL, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4160 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 90:
#line 838 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EDIV, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4166 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 91:
#line 840 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (LEFTDIV, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4172 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 92:
#line 842 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (ELEFTDIV, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4178 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 93:
#line 846 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 4184 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 94:
#line 848 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (PLUS_PLUS, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4190 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 95:
#line 850 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (MINUS_MINUS, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4196 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 96:
#line 852 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-2].tree_expression_type), nullptr, '(');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1.
                        YYABORT;
                      }
                  }
#line 4212 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 97:
#line 864 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_argument_list_type), '(');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4228 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 98:
#line 876 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-2].tree_expression_type), nullptr, '{');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1.
                        YYABORT;
                      }
                  }
#line 4244 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 99:
#line 888 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_argument_list_type), '{');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4260 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 100:
#line 900 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_indirect_ref ((yyvsp[-2].tree_expression_type), (yyvsp[0].tok_val)->text ()); }
#line 4266 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 101:
#line 902 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_indirect_ref ((yyvsp[-4].tree_expression_type), (yyvsp[-1].tree_expression_type));
                  }
#line 4277 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 102:
#line 909 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (PLUS_PLUS, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4283 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 103:
#line 911 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (MINUS_MINUS, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4289 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 104:
#line 913 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (EXPR_NOT, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4295 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 105:
#line 915 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op ('+', (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4301 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 106:
#line 917 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op ('-', (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4307 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 107:
#line 921 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_expression_type) = parser.make_colon_expression ((yyvsp[-2].tree_expression_type), (yyvsp[0].tree_expression_type));

                    if (! (yyval.tree_expression_type))
                      {
                        // finish_colon_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4323 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 108:
#line 933 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].tok_val));
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_expression_type) = parser.make_colon_expression ((yyvsp[-4].tree_expression_type), (yyvsp[0].tree_expression_type), (yyvsp[-2].tree_expression_type));

                    if (! (yyval.tree_expression_type))
                      {
                        // finish_colon_expression deleted $1, $3, and $5.
                        YYABORT;
                      }
                  }
#line 4340 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 109:
#line 948 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 4346 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 110:
#line 950 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 4352 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 111:
#line 952 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_LT, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4358 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 112:
#line 954 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_LE, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4364 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 113:
#line 956 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_EQ, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4370 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 114:
#line 958 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_GE, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4376 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 115:
#line 960 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_GT, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4382 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 116:
#line 962 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_NE, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4388 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 117:
#line 964 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_AND, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4394 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 118:
#line 966 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_OR, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4400 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 119:
#line 968 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_boolean_op (EXPR_AND_AND, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4406 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 120:
#line 970 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_boolean_op (EXPR_OR_OR, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4412 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 121:
#line 974 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_argument_list_type) = parser.validate_matrix_for_assignment ((yyvsp[0].tree_expression_type));

                    if ((yyval.tree_argument_list_type))
                      { lexer.m_looking_at_matrix_or_assign_lhs = false; }
                    else
                      {
                        // validate_matrix_for_assignment deleted $1.
                        YYABORT;
                      }
                  }
#line 4428 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 122:
#line 988 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op ('=', (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4434 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 123:
#line 990 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (ADD_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4440 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 124:
#line 992 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (SUB_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4446 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 125:
#line 994 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (MUL_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4452 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 126:
#line 996 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (DIV_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4458 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 127:
#line 998 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (LEFTDIV_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4464 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 128:
#line 1000 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (POW_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4470 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 129:
#line 1002 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (EMUL_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4476 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 130:
#line 1004 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (EDIV_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4482 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 131:
#line 1006 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (ELEFTDIV_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4488 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 132:
#line 1008 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (EPOW_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4494 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 133:
#line 1010 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (AND_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4500 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 134:
#line 1012 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (OR_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4506 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 135:
#line 1016 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if ((yyvsp[0].tree_expression_type) && ((yyvsp[0].tree_expression_type)->is_matrix () || (yyvsp[0].tree_expression_type)->iscell ()))
                      {
                        if (parser.validate_array_list ((yyvsp[0].tree_expression_type)))
                          (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type);
                        else
                          {
                            delete (yyvsp[0].tree_expression_type);
                            YYABORT;
                          }
                      }
                    else
                      (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type);
                  }
#line 4525 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 136:
#line 1031 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! (yyvsp[0].tree_expression_type))
                      YYABORT;

                    (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type);
                  }
#line 4536 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 137:
#line 1038 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_anon_fcn_handle_type); }
#line 4542 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 138:
#line 1046 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_decl_command_type); }
#line 4548 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 139:
#line 1048 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4554 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 140:
#line 1050 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4560 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 141:
#line 1052 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4566 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 142:
#line 1054 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4572 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 143:
#line 1056 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_function_def_type); }
#line 4578 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 144:
#line 1058 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4584 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 145:
#line 1066 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_decl_command_type) = parser.make_decl_command (GLOBAL, (yyvsp[-1].tok_val), (yyvsp[0].tree_decl_init_list_type));
                    lexer.m_looking_at_decl_list = false;
                  }
#line 4593 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 146:
#line 1071 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_decl_command_type) = parser.make_decl_command (PERSISTENT, (yyvsp[-1].tok_val), (yyvsp[0].tree_decl_init_list_type));
                    lexer.m_looking_at_decl_list = false;
                  }
#line 4602 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 147:
#line 1078 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_decl_init_list_type) = new octave::tree_decl_init_list ((yyvsp[0].tree_decl_elt_type)); }
#line 4608 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 148:
#line 1080 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_decl_init_list_type)->append ((yyvsp[0].tree_decl_elt_type));
                    (yyval.tree_decl_init_list_type) = (yyvsp[-1].tree_decl_init_list_type);
                  }
#line 4617 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 149:
#line 1087 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;
                    lexer.m_looking_at_initializer_expression = true;
                  }
#line 4626 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 150:
#line 1093 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_decl_elt_type) = new octave::tree_decl_elt ((yyvsp[0].tree_identifier_type)); }
#line 4632 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 151:
#line 1095 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));

                    lexer.m_looking_at_initializer_expression = false;
                    (yyval.tree_decl_elt_type) = new octave::tree_decl_elt ((yyvsp[-3].tree_identifier_type), (yyvsp[0].tree_expression_type));
                  }
#line 4643 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 152:
#line 1108 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_if_command_type); }
#line 4649 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 153:
#line 1110 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_switch_command_type); }
#line 4655 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 154:
#line 1118 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.tree_if_command_type) = parser.finish_if_command ((yyvsp[-3].tok_val), (yyvsp[-1].tree_if_command_list_type), (yyvsp[0].tok_val), (yyvsp[-2].comment_type))))
                      {
                        // finish_if_command deleted $3.
                        YYABORT;
                      }
                  }
#line 4667 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 155:
#line 1128 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_if_command_list_type) = (yyvsp[0].tree_if_command_list_type); }
#line 4673 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 156:
#line 1130 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_if_command_list_type)->append ((yyvsp[0].tree_if_clause_type));
                    (yyval.tree_if_command_list_type) = (yyvsp[-1].tree_if_command_list_type);
                  }
#line 4682 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 157:
#line 1137 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-3].tree_expression_type)->mark_braindead_shortcircuit ();

                    (yyval.tree_if_command_list_type) = parser.start_if_command ((yyvsp[-3].tree_expression_type), (yyvsp[0].tree_statement_list_type));
                  }
#line 4694 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 158:
#line 1145 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_if_command_list_type)->append ((yyvsp[0].tree_if_clause_type));
                    (yyval.tree_if_command_list_type) = (yyvsp[-1].tree_if_command_list_type);
                  }
#line 4703 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 159:
#line 1152 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-4].punct_type));
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-3].tree_expression_type)->mark_braindead_shortcircuit ();

                    (yyval.tree_if_clause_type) = parser.make_elseif_clause ((yyvsp[-6].tok_val), (yyvsp[-3].tree_expression_type), (yyvsp[0].tree_statement_list_type), (yyvsp[-5].comment_type));
                  }
#line 4716 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 160:
#line 1163 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].tok_val));
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyval.tree_if_clause_type) = new octave::tree_if_clause ((yyvsp[0].tree_statement_list_type), (yyvsp[-2].comment_type));
                  }
#line 4727 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 161:
#line 1176 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_switch_command_type) = parser.finish_switch_command ((yyvsp[-5].tok_val), (yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_switch_case_list_type), (yyvsp[0].tok_val), (yyvsp[-4].comment_type))))
                      {
                        // finish_switch_command deleted $3 adn $5.
                        YYABORT;
                      }
                  }
#line 4741 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 162:
#line 1188 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_switch_case_list_type) = new octave::tree_switch_case_list (); }
#line 4747 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 163:
#line 1190 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_switch_case_list_type) = new octave::tree_switch_case_list ((yyvsp[0].tree_switch_case_type)); }
#line 4753 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 164:
#line 1192 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_switch_case_list_type) = (yyvsp[0].tree_switch_case_list_type); }
#line 4759 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 165:
#line 1194 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_switch_case_list_type)->append ((yyvsp[0].tree_switch_case_type));
                    (yyval.tree_switch_case_list_type) = (yyvsp[-1].tree_switch_case_list_type);
                  }
#line 4768 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 166:
#line 1201 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_switch_case_list_type) = new octave::tree_switch_case_list ((yyvsp[0].tree_switch_case_type)); }
#line 4774 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 167:
#line 1203 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_switch_case_list_type)->append ((yyvsp[0].tree_switch_case_type));
                    (yyval.tree_switch_case_list_type) = (yyvsp[-1].tree_switch_case_list_type);
                  }
#line 4783 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 168:
#line 1210 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-4].punct_type));
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyval.tree_switch_case_type) = parser.make_switch_case ((yyvsp[-6].tok_val), (yyvsp[-3].tree_expression_type), (yyvsp[0].tree_statement_list_type), (yyvsp[-5].comment_type));
                  }
#line 4794 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 169:
#line 1219 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].tok_val));
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyval.tree_switch_case_type) = new octave::tree_switch_case ((yyvsp[0].tree_statement_list_type), (yyvsp[-2].comment_type));
                  }
#line 4805 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 170:
#line 1232 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].punct_type));

                    (yyvsp[-4].tree_expression_type)->mark_braindead_shortcircuit ();

                    if (! ((yyval.tree_command_type) = parser.make_while_command ((yyvsp[-6].tok_val), (yyvsp[-4].tree_expression_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-5].comment_type))))
                      {
                        // make_while_command deleted $3 and $6.
                        YYABORT;
                      }
                  }
#line 4821 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 171:
#line 1244 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-5].tok_val));
                    YYUSE ((yyvsp[-3].punct_type));

                    (yyval.tree_command_type) = parser.make_do_until_command ((yyvsp[-1].tok_val), (yyvsp[-2].tree_statement_list_type), (yyvsp[0].tree_expression_type), (yyvsp[-4].comment_type));
                  }
#line 4832 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 172:
#line 1251 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-5].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_for_command (FOR, (yyvsp[-8].tok_val), (yyvsp[-6].tree_argument_list_type), (yyvsp[-4].tree_expression_type),
                                                         nullptr, (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-7].comment_type))))
                      {
                        // make_for_command deleted $3, $5, and $8.
                        YYABORT;
                      }
                  }
#line 4848 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 173:
#line 1263 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-7].tok_val));
                    YYUSE ((yyvsp[-5].tok_val));
                    YYUSE ((yyvsp[-3].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_for_command (FOR, (yyvsp[-9].tok_val), (yyvsp[-6].tree_argument_list_type), (yyvsp[-4].tree_expression_type),
                                                         nullptr, (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-8].comment_type))))
                      {
                        // make_for_command deleted $4, $6, and $9.
                        YYABORT;
                      }
                  }
#line 4866 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 174:
#line 1277 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-5].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_for_command (PARFOR, (yyvsp[-8].tok_val), (yyvsp[-6].tree_argument_list_type), (yyvsp[-4].tree_expression_type),
                                                         nullptr, (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-7].comment_type))))
                      {
                        // make_for_command deleted $3, $5, and $8.
                        YYABORT;
                      }
                  }
#line 4882 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 175:
#line 1289 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-9].tok_val));
                    YYUSE ((yyvsp[-7].tok_val));
                    YYUSE ((yyvsp[-5].tok_val));
                    YYUSE ((yyvsp[-3].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_for_command (PARFOR, (yyvsp[-11].tok_val), (yyvsp[-8].tree_argument_list_type), (yyvsp[-6].tree_expression_type),
                                                         (yyvsp[-4].tree_expression_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-10].comment_type))))
                      {
                        // make_for_command deleted $4, $6, $8, and $11.
                        YYABORT;
                      }
                  }
#line 4901 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 176:
#line 1310 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.tree_command_type) = parser.make_break_command ((yyvsp[0].tok_val))))
                      YYABORT;
                  }
#line 4910 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 177:
#line 1315 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.tree_command_type) = parser.make_continue_command ((yyvsp[0].tok_val))))
                      YYABORT;
                  }
#line 4919 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 178:
#line 1320 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = parser.make_return_command ((yyvsp[0].tok_val)); }
#line 4925 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 179:
#line 1329 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-6].punct_type));
                    YYUSE ((yyvsp[-4].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_unwind_command ((yyvsp[-8].tok_val), (yyvsp[-5].tree_statement_list_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-7].comment_type), (yyvsp[-3].comment_type))))
                      {
                        // make_unwind_command deleted $4 and $8.
                        YYABORT;
                      }
                  }
#line 4941 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 180:
#line 1342 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-6].punct_type));
                    YYUSE ((yyvsp[-4].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_try_command ((yyvsp[-8].tok_val), (yyvsp[-5].tree_statement_list_type), (yyvsp[-2].punct_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-7].comment_type), (yyvsp[-3].comment_type))))
                      {
                        // make_try_command deleted $4 and $8.
                        YYABORT;
                      }
                  }
#line 4957 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 181:
#line 1354 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_try_command ((yyvsp[-4].tok_val), (yyvsp[-1].tree_statement_list_type), 0, nullptr,
                                                         (yyvsp[0].tok_val), (yyvsp[-3].comment_type), nullptr)))
                      {
                        // make_try_command deleted $4.
                        YYABORT;
                      }
                  }
#line 4972 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 182:
#line 1371 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! parser.push_fcn_symtab ())
                      YYABORT;

                    (yyval.dummy_type) = 0;
                  }
#line 4983 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 183:
#line 1384 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.dummy_type) = 0;
                    lexer.m_looking_at_parameter_list = true;

                    if (lexer.m_looking_at_function_handle)
                      {
                        // Will get a real name later.
                        lexer.m_symtab_context.push (octave::symbol_scope ("parser:param_lsit_beg"));
                        lexer.m_looking_at_function_handle--;
                        lexer.m_looking_at_anon_fcn_args = true;
                      }
                  }
#line 5002 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 184:
#line 1401 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.dummy_type) = 0;
                    lexer.m_looking_at_parameter_list = false;
                    lexer.m_looking_for_object_index = false;
                  }
#line 5014 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 185:
#line 1411 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_parameter_list_type) = nullptr; }
#line 5020 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 186:
#line 1413 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_parameter_list_type) = (yyvsp[0].tree_parameter_list_type); }
#line 5026 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 187:
#line 1417 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if ((yyvsp[-1].tree_parameter_list_type))
                      lexer.mark_as_variables ((yyvsp[-1].tree_parameter_list_type)->variable_names ());

                    (yyval.tree_parameter_list_type) = (yyvsp[-1].tree_parameter_list_type);
                  }
#line 5037 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 188:
#line 1424 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_parameter_list_type) = nullptr;
                    parser.bison_error ("invalid parameter list");
                    YYABORT;
                  }
#line 5047 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 189:
#line 1432 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_parameter_list_type) = nullptr; }
#line 5053 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 190:
#line 1434 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[0].tree_parameter_list_type)->mark_as_formal_parameters ();

                    if (parser.validate_param_list ((yyvsp[0].tree_parameter_list_type), octave::tree_parameter_list::in))
                      {
                        lexer.mark_as_variables ((yyvsp[0].tree_parameter_list_type)->variable_names ());
                        (yyval.tree_parameter_list_type) = (yyvsp[0].tree_parameter_list_type);
                      }
                    else
                      {
                        delete (yyvsp[0].tree_parameter_list_type);
                        YYABORT;
                      }
                  }
#line 5072 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 191:
#line 1451 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_parameter_list_type) = new octave::tree_parameter_list ((yyvsp[0].tree_decl_elt_type)); }
#line 5078 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 192:
#line 1453 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_parameter_list_type)->append ((yyvsp[0].tree_decl_elt_type));
                    (yyval.tree_parameter_list_type) = (yyvsp[-2].tree_parameter_list_type);
                  }
#line 5089 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 193:
#line 1462 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_decl_elt_type) = (yyvsp[0].tree_decl_elt_type); }
#line 5095 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 194:
#line 1464 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_decl_elt_type) = new octave::tree_decl_elt ((yyvsp[0].tree_identifier_type)); }
#line 5101 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 195:
#line 1472 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    lexer.m_looking_at_return_list = false;

                    (yyval.tree_parameter_list_type) = new octave::tree_parameter_list ();
                  }
#line 5114 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 196:
#line 1481 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    lexer.m_looking_at_return_list = false;

                    octave::tree_parameter_list *tmp = new octave::tree_parameter_list ((yyvsp[0].tree_identifier_type));

                    // Even though this parameter list can contain only
                    // a single identifier, we still need to validate it
                    // to check for varargin or varargout.

                    if (parser.validate_param_list (tmp, octave::tree_parameter_list::out))
                      (yyval.tree_parameter_list_type) = tmp;
                    else
                      {
                        delete tmp;
                        YYABORT;
                      }
                  }
#line 5136 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 197:
#line 1499 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    lexer.m_looking_at_return_list = false;

                    // Check for duplicate parameter names, varargin,
                    // or varargout.

                    if (parser.validate_param_list ((yyvsp[-1].tree_parameter_list_type), octave::tree_parameter_list::out))
                      (yyval.tree_parameter_list_type) = (yyvsp[-1].tree_parameter_list_type);
                    else
                      {
                        delete (yyvsp[-1].tree_parameter_list_type);
                        YYABORT;
                      }
                  }
#line 5158 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 198:
#line 1519 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_parameter_list_type) = new octave::tree_parameter_list (new octave::tree_decl_elt ((yyvsp[0].tree_identifier_type))); }
#line 5164 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 199:
#line 1521 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_parameter_list_type)->append (new octave::tree_decl_elt ((yyvsp[0].tree_identifier_type)));
                    (yyval.tree_parameter_list_type) = (yyvsp[-2].tree_parameter_list_type);
                  }
#line 5175 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 200:
#line 1535 "../libinterp/parse-tree/oct-parse.yy"
                  { parser.parsing_local_functions (true); }
#line 5181 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 201:
#line 1539 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;

                    // This scope may serve as the parent scope for local
                    // functions in classdef files..
                    lexer.m_symtab_context.push (octave::symbol_scope ("parser:push_script_symtab"));
                  }
#line 5193 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 202:
#line 1549 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.dummy_type) = 0; }
#line 5199 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 203:
#line 1553 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].punct_type));

                    if (lexer.m_reading_fcn_file)
                      {
                        // Delete the dummy statement_list we created
                        // after parsing the function.  Any function
                        // definitions found in the file have already
                        // been stored in the symbol table or in
                        // base_parser::m_primary_fcn.

                        // Unused symbol table context.
                        lexer.m_symtab_context.pop ();

                        delete (yyvsp[-1].tree_statement_list_type);
                      }
                    else
                      {
                        octave::tree_statement *end_of_script
                          = parser.make_end ("endscript", true,
                                             (yyvsp[0].tok_val)->beg_pos (), (yyvsp[0].tok_val)->end_pos ());

                        parser.make_script ((yyvsp[-1].tree_statement_list_type), end_of_script);
                      }

                    (yyval.tree_command_type) = nullptr;
                  }
#line 5231 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 204:
#line 1581 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-5].punct_type));
                    YYUSE ((yyvsp[-2].punct_type));
                    YYUSE ((yyvsp[0].tok_val));

                    // Unused symbol table context.
                    lexer.m_symtab_context.pop ();

                    parser.finish_classdef_file ((yyvsp[-4].tree_classdef_type), (yyvsp[-1].tree_statement_list_type));

                    (yyval.tree_command_type) = nullptr;
                  }
#line 5248 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 205:
#line 1600 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tok_val) = (yyvsp[0].tok_val);
                    if (lexer.m_reading_classdef_file
                        || lexer.m_parsing_classdef)
                      lexer.m_maybe_classdef_get_set_method = true;
                  }
#line 5259 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 206:
#line 1609 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_identifier_type) = parser.make_fcn_name ((yyvsp[0].tree_identifier_type));
                    if (! (yyval.tree_identifier_type))
                      {
                        // make_fcn_name deleted $1.
                        YYABORT;
                      }
                  }
#line 5272 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 207:
#line 1618 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[-1].tok_val));

                    lexer.m_parsed_function_name.top () = true;
                    lexer.m_maybe_classdef_get_set_method = false;
                    lexer.m_parsing_classdef_get_method = true;
                    (yyval.tree_identifier_type) = (yyvsp[0].tree_identifier_type);
                  }
#line 5286 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 208:
#line 1628 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[-1].tok_val));

                    lexer.m_parsed_function_name.top () = true;
                    lexer.m_maybe_classdef_get_set_method = false;
                    lexer.m_parsing_classdef_set_method = true;
                    (yyval.tree_identifier_type) = (yyvsp[0].tree_identifier_type);
                  }
#line 5300 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 209:
#line 1640 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    parser.endfunction_found (true);

                    if (parser.end_token_ok ((yyvsp[0].tok_val), octave::token::function_end))
                      (yyval.tree_statement_type) = parser.make_end ("endfunction", false,
                                            (yyvsp[0].tok_val)->beg_pos (), (yyvsp[0].tok_val)->end_pos ());
                    else
                      {
                        parser.end_token_error ((yyvsp[0].tok_val), octave::token::function_end);
                        YYABORT;
                      }
                  }
#line 5317 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 210:
#line 1653 "../libinterp/parse-tree/oct-parse.yy"
                  {
// A lot of tests are based on the assumption that this is OK
//                  if (lexer.m_reading_script_file)
//                    {
//                      parser.bison_error ("function body open at end of script");
//                      YYABORT;
//                    }

                    if (parser.endfunction_found ())
                      {
                        parser.bison_error ("inconsistent function endings -- "
                                 "if one function is explicitly ended, "
                                 "so must all the others");
                        YYABORT;
                      }

                    if (! (lexer.m_reading_fcn_file || lexer.m_reading_script_file
                           || lexer.input_from_eval_string ()))
                      {
                        parser.bison_error ("function body open at end of input");
                        YYABORT;
                      }

                    if (lexer.m_reading_classdef_file)
                      {
                        parser.bison_error ("classdef body open at end of input");
                        YYABORT;
                      }

                    (yyval.tree_statement_type) = parser.make_end ("endfunction", true,
                                          (yyvsp[0].tok_val)->beg_pos (), (yyvsp[0].tok_val)->end_pos ());
                  }
#line 5354 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 211:
#line 1689 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].punct_type));

                    (yyval.tree_function_def_type) = parser.make_function ((yyvsp[-6].tok_val), nullptr, (yyvsp[-4].tree_identifier_type), (yyvsp[-3].tree_parameter_list_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tree_statement_type), (yyvsp[-5].comment_type));
                  }
#line 5364 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 212:
#line 1696 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-5].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    (yyval.tree_function_def_type) = parser.make_function ((yyvsp[-8].tok_val), (yyvsp[-6].tree_parameter_list_type), (yyvsp[-4].tree_identifier_type), (yyvsp[-3].tree_parameter_list_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tree_statement_type), (yyvsp[-7].comment_type));
                  }
#line 5375 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 213:
#line 1709 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! lexer.m_reading_classdef_file)
                      {
                        parser.bison_error ("classdef must appear inside a file containing only a class definition");
                        YYABORT;
                      }

                    // Create invalid parent scope.
                    lexer.m_symtab_context.push (octave::symbol_scope ());
                    lexer.m_parsing_classdef = true;
                    lexer.m_parsing_classdef_decl = true;
                    (yyval.tok_val) = (yyvsp[0].tok_val);
                  }
#line 5393 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 214:
#line 1725 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].punct_type));
                    YYUSE ((yyvsp[-1].punct_type));

                    lexer.m_parsing_classdef = false;

                    if (! ((yyval.tree_classdef_type) = parser.make_classdef ((yyvsp[-8].tok_val), (yyvsp[-6].tree_classdef_attribute_list_type), (yyvsp[-5].tree_identifier_type), (yyvsp[-4].tree_classdef_superclass_list_type), (yyvsp[-2].tree_classdef_body_type), (yyvsp[0].tok_val), (yyvsp[-7].comment_type))))
                      {
                        // make_classdef deleted $3, $4, $5, and $7.
                        YYABORT;
                      }
                  }
#line 5410 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 215:
#line 1738 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    lexer.m_parsing_classdef = false;

                    if (! ((yyval.tree_classdef_type) = parser.make_classdef ((yyvsp[-6].tok_val), (yyvsp[-4].tree_classdef_attribute_list_type), (yyvsp[-3].tree_identifier_type), (yyvsp[-2].tree_classdef_superclass_list_type), nullptr,
                                                      (yyvsp[0].tok_val), (yyvsp[-5].comment_type))))
                      {
                        // make_classdef deleted $3, $4, and $5.
                        YYABORT;
                      }
                  }
#line 5427 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 216:
#line 1753 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_attribute_list_type) = nullptr; }
#line 5433 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 217:
#line 1755 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_classdef_attribute_list_type) = (yyvsp[-1].tree_classdef_attribute_list_type);
                  }
#line 5444 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 218:
#line 1764 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_attribute_list_type) = new octave::tree_classdef_attribute_list ((yyvsp[0].tree_classdef_attribute_type)); }
#line 5450 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 219:
#line 1766 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_classdef_attribute_list_type)->append ((yyvsp[0].tree_classdef_attribute_type));
                    (yyval.tree_classdef_attribute_list_type) = (yyvsp[-2].tree_classdef_attribute_list_type);
                  }
#line 5461 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 220:
#line 1775 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_attribute_type) = new octave::tree_classdef_attribute ((yyvsp[0].tree_identifier_type)); }
#line 5467 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 221:
#line 1777 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));

                    lexer.m_looking_at_initializer_expression = false;
                    (yyval.tree_classdef_attribute_type) = new octave::tree_classdef_attribute ((yyvsp[-3].tree_identifier_type), (yyvsp[0].tree_expression_type));
                  }
#line 5478 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 222:
#line 1784 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_classdef_attribute_type) = new octave::tree_classdef_attribute ((yyvsp[0].tree_identifier_type), false);
                  }
#line 5488 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 223:
#line 1793 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    lexer.m_parsing_classdef_decl = false;
                    lexer.m_parsing_classdef_superclass = false;
                    (yyval.tree_classdef_superclass_list_type) = nullptr;
                  }
#line 5498 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 224:
#line 1799 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    lexer.m_parsing_classdef_decl = false;
                    lexer.m_parsing_classdef_superclass = false;
                    (yyval.tree_classdef_superclass_list_type) = (yyvsp[0].tree_classdef_superclass_list_type);
                  }
#line 5508 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 225:
#line 1807 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_classdef_superclass_list_type) = new octave::tree_classdef_superclass_list ((yyvsp[0].tree_classdef_superclass_type));
                  }
#line 5518 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 226:
#line 1813 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_classdef_superclass_list_type)->append ((yyvsp[0].tree_classdef_superclass_type));
                    (yyval.tree_classdef_superclass_list_type) = (yyvsp[-2].tree_classdef_superclass_list_type);
                  }
#line 5529 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 227:
#line 1822 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_superclass_type) = new octave::tree_classdef_superclass ((yyvsp[0].tok_val)->text ()); }
#line 5535 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 228:
#line 1826 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = new octave::tree_classdef_body ((yyvsp[0].tree_classdef_properties_block_type)); }
#line 5541 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 229:
#line 1828 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = new octave::tree_classdef_body ((yyvsp[0].tree_classdef_methods_block_type)); }
#line 5547 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 230:
#line 1830 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = new octave::tree_classdef_body ((yyvsp[0].tree_classdef_events_block_type)); }
#line 5553 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 231:
#line 1832 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = new octave::tree_classdef_body ((yyvsp[0].tree_classdef_enum_block_type)); }
#line 5559 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 232:
#line 1834 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_body_type)->append ((yyvsp[0].tree_classdef_properties_block_type));
                    (yyval.tree_classdef_body_type) = (yyvsp[-2].tree_classdef_body_type);
                  }
#line 5570 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 233:
#line 1841 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_body_type)->append ((yyvsp[0].tree_classdef_methods_block_type));
                    (yyval.tree_classdef_body_type) = (yyvsp[-2].tree_classdef_body_type);
                  }
#line 5581 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 234:
#line 1848 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_body_type)->append ((yyvsp[0].tree_classdef_events_block_type));
                    (yyval.tree_classdef_body_type) = (yyvsp[-2].tree_classdef_body_type);
                  }
#line 5592 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 235:
#line 1855 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_body_type)->append ((yyvsp[0].tree_classdef_enum_block_type));
                    (yyval.tree_classdef_body_type) = (yyvsp[-2].tree_classdef_body_type);
                  }
#line 5603 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 236:
#line 1865 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].punct_type));
                    YYUSE ((yyvsp[-1].punct_type));

                    if (! ((yyval.tree_classdef_properties_block_type) = parser.make_classdef_properties_block
                           ((yyvsp[-6].tok_val), (yyvsp[-4].tree_classdef_attribute_list_type), (yyvsp[-2].tree_classdef_property_list_type), (yyvsp[0].tok_val), (yyvsp[-5].comment_type))))
                      {
                        // make_classdef_properties_block delete $3 and $5.
                        YYABORT;
                      }
                  }
#line 5619 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 237:
#line 1877 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    if (! ((yyval.tree_classdef_properties_block_type) = parser.make_classdef_properties_block
                           ((yyvsp[-4].tok_val), (yyvsp[-2].tree_classdef_attribute_list_type), nullptr, (yyvsp[0].tok_val), (yyvsp[-3].comment_type))))
                      {
                        // make_classdef_properties_block delete $3.
                        YYABORT;
                      }
                  }
#line 5634 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 238:
#line 1891 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_property_list_type) = new octave::tree_classdef_property_list ((yyvsp[0].tree_classdef_property_type)); }
#line 5640 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 239:
#line 1893 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_property_list_type)->append ((yyvsp[0].tree_classdef_property_type));
                    (yyval.tree_classdef_property_list_type) = (yyvsp[-2].tree_classdef_property_list_type);
                  }
#line 5651 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 240:
#line 1902 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_property_type) = new octave::tree_classdef_property ((yyvsp[0].tree_identifier_type)); }
#line 5657 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 241:
#line 1904 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));

                    lexer.m_looking_at_initializer_expression = false;
                    (yyval.tree_classdef_property_type) = new octave::tree_classdef_property ((yyvsp[-3].tree_identifier_type), (yyvsp[0].tree_expression_type));
                  }
#line 5668 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 242:
#line 1913 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].punct_type));
                    YYUSE ((yyvsp[-1].punct_type));

                    if (! ((yyval.tree_classdef_methods_block_type) = parser.make_classdef_methods_block
                           ((yyvsp[-6].tok_val), (yyvsp[-4].tree_classdef_attribute_list_type), (yyvsp[-2].tree_classdef_methods_list_type), (yyvsp[0].tok_val), (yyvsp[-5].comment_type))))
                      {
                        // make_classdef_methods_block deleted $3 and $5.
                        YYABORT;
                      }
                  }
#line 5684 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 243:
#line 1925 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    if (! ((yyval.tree_classdef_methods_block_type) = parser.make_classdef_methods_block
                           ((yyvsp[-4].tok_val), (yyvsp[-2].tree_classdef_attribute_list_type), nullptr, (yyvsp[0].tok_val), (yyvsp[-3].comment_type))))
                      {
                        // make_classdef_methods_block deleted $3.
                        YYABORT;
                      }
                  }
#line 5699 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 244:
#line 1939 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.octave_user_function_type) = parser.start_classdef_external_method ((yyvsp[0].tree_identifier_type), nullptr)))
                      YYABORT;
                  }
#line 5708 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 245:
#line 1944 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.octave_user_function_type) = parser.start_classdef_external_method ((yyvsp[-1].tree_identifier_type), (yyvsp[0].tree_parameter_list_type))))
                      YYABORT;
                  }
#line 5717 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 246:
#line 1951 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_function_def_type) = parser.finish_classdef_external_method ((yyvsp[0].octave_user_function_type), nullptr, (yyvsp[-1].comment_type)); }
#line 5723 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 247:
#line 1953 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    lexer.m_defining_func++;
                    lexer.m_parsed_function_name.push (false);
                  }
#line 5734 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 248:
#line 1960 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    lexer.m_defining_func--;
                    lexer.m_parsed_function_name.pop ();
                    (yyval.tree_function_def_type) = parser.finish_classdef_external_method ((yyvsp[0].octave_user_function_type), (yyvsp[-3].tree_parameter_list_type), (yyvsp[-4].comment_type));
                  }
#line 5744 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 249:
#line 1968 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_function_def_type) = (yyvsp[0].tree_function_def_type); }
#line 5750 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 250:
#line 1970 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_function_def_type) = (yyvsp[0].tree_function_def_type); }
#line 5756 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 251:
#line 1974 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    octave_value fcn;
                    if ((yyvsp[0].tree_function_def_type))
                      fcn = (yyvsp[0].tree_function_def_type)->function ();
                    delete (yyvsp[0].tree_function_def_type);
                    (yyval.tree_classdef_methods_list_type) = new octave::tree_classdef_methods_list (fcn);
                  }
#line 5768 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 252:
#line 1982 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    octave_value fcn;
                    if ((yyvsp[0].tree_function_def_type))
                      fcn = (yyvsp[0].tree_function_def_type)->function ();
                    delete (yyvsp[0].tree_function_def_type);

                    (yyvsp[-2].tree_classdef_methods_list_type)->append (fcn);
                    (yyval.tree_classdef_methods_list_type) = (yyvsp[-2].tree_classdef_methods_list_type);
                  }
#line 5784 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 253:
#line 1996 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].punct_type));
                    YYUSE ((yyvsp[-1].punct_type));

                    if (! ((yyval.tree_classdef_events_block_type) = parser.make_classdef_events_block
                           ((yyvsp[-6].tok_val), (yyvsp[-4].tree_classdef_attribute_list_type), (yyvsp[-2].tree_classdef_events_list_type), (yyvsp[0].tok_val), (yyvsp[-5].comment_type))))
                      {
                        // make_classdef_events_block deleted $3 and $5.
                        YYABORT;
                      }
                  }
#line 5800 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 254:
#line 2008 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    if (! ((yyval.tree_classdef_events_block_type) = parser.make_classdef_events_block
                           ((yyvsp[-4].tok_val), (yyvsp[-2].tree_classdef_attribute_list_type), nullptr, (yyvsp[0].tok_val), (yyvsp[-3].comment_type))))
                      {
                        // make_classdef_events_block deleted $3.
                        YYABORT;
                      }
                  }
#line 5815 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 255:
#line 2021 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_events_list_type) = new octave::tree_classdef_events_list ((yyvsp[0].tree_classdef_event_type)); }
#line 5821 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 256:
#line 2023 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_events_list_type)->append ((yyvsp[0].tree_classdef_event_type));
                    (yyval.tree_classdef_events_list_type) = (yyvsp[-2].tree_classdef_events_list_type);
                  }
#line 5832 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 257:
#line 2032 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_event_type) = new octave::tree_classdef_event ((yyvsp[0].tree_identifier_type)); }
#line 5838 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 258:
#line 2036 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].punct_type));
                    YYUSE ((yyvsp[-1].punct_type));

                    if (! ((yyval.tree_classdef_enum_block_type) = parser.make_classdef_enum_block
                           ((yyvsp[-6].tok_val), (yyvsp[-4].tree_classdef_attribute_list_type), (yyvsp[-2].tree_classdef_enum_list_type), (yyvsp[0].tok_val), (yyvsp[-5].comment_type))))
                      {
                        // make_classdef_enum_block deleted $3 and $5.
                        YYABORT;
                      }
                  }
#line 5854 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 259:
#line 2048 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    if (! ((yyval.tree_classdef_enum_block_type) = parser.make_classdef_enum_block
                           ((yyvsp[-4].tok_val), (yyvsp[-2].tree_classdef_attribute_list_type), nullptr, (yyvsp[0].tok_val), (yyvsp[-3].comment_type))))
                      {
                        // make_classdef_enum_block deleted $3.
                        YYABORT;
                      }
                  }
#line 5869 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 260:
#line 2061 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_enum_list_type) = new octave::tree_classdef_enum_list ((yyvsp[0].tree_classdef_enum_type)); }
#line 5875 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 261:
#line 2063 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_enum_list_type)->append ((yyvsp[0].tree_classdef_enum_type));
                    (yyval.tree_classdef_enum_list_type) = (yyvsp[-2].tree_classdef_enum_list_type);
                  }
#line 5886 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 262:
#line 2072 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_classdef_enum_type) = new octave::tree_classdef_enum ((yyvsp[-3].tree_identifier_type), (yyvsp[-1].tree_expression_type));
                  }
#line 5897 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 263:
#line 2085 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;
                    lexer.m_at_beginning_of_statement = true;
                  }
#line 5906 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 264:
#line 2092 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;
                    lexer.m_at_beginning_of_statement = true;
                    lexer.m_parsing_anon_fcn_body = true;
                  }
#line 5916 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 265:
#line 2100 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.comment_type) = lexer.get_comment (); }
#line 5922 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 266:
#line 2104 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;
                    std::string msg = (yyvsp[0].tok_val)->text ();
                    parser.bison_error (msg.c_str ());
                  }
#line 5932 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 267:
#line 2110 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.dummy_type) = 0; }
#line 5938 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 268:
#line 2114 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = ',';
                  }
#line 5948 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 269:
#line 2120 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = ';';
                  }
#line 5958 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 270:
#line 2126 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 5968 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 271:
#line 2132 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 5978 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 272:
#line 2140 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = 0; }
#line 5984 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 273:
#line 2142 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = (yyvsp[0].punct_type); }
#line 5990 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 274:
#line 2146 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = 0; }
#line 5996 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 275:
#line 2148 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = (yyvsp[0].punct_type); }
#line 6002 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 276:
#line 2152 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = '\n';
                  }
#line 6012 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 277:
#line 2158 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6022 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 278:
#line 2166 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = ',';
                  }
#line 6032 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 279:
#line 2172 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = ';';
                  }
#line 6042 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 280:
#line 2178 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = '\n';
                  }
#line 6052 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 281:
#line 2184 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6062 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 282:
#line 2190 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6072 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 283:
#line 2196 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6082 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 284:
#line 2204 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = 0; }
#line 6088 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 285:
#line 2206 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = (yyvsp[0].punct_type); }
#line 6094 "libinterp/parse-tree/oct-parse.cc"
    break;


#line 6098 "libinterp/parse-tree/oct-parse.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (parser, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (parser, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, parser);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, parser);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (parser, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, parser);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[+*yyssp], yyvsp, parser);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  yyps->yynew = 1;


/*-----------------------------------------.
| yypushreturn -- ask for the next token.  |
`-----------------------------------------*/
yypushreturn:
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2209 "../libinterp/parse-tree/oct-parse.yy"


#if defined (HAVE_PRAGMA_GCC_DIAGNOSTIC)
   // Restore prevailing warning state for remainder of the file.
#  pragma GCC diagnostic pop
#endif

// Generic error messages.

#undef lexer
#undef scanner

static void
yyerror (octave::base_parser& parser, const char *s)
{
  parser.bison_error (s);
}

namespace octave
{
  size_t
  base_parser::parent_scope_info::size (void) const
  {
    return m_info.size ();
  }

  void
  base_parser::parent_scope_info::push (const value_type& elt)
  {
    m_info.push_back (elt);
  }

  void
  base_parser::parent_scope_info::push (const symbol_scope& scope)
  {
    push (value_type (scope, ""));
  }

  void
  base_parser::parent_scope_info::pop (void)
  {
    m_info.pop_back ();
  }

  bool
  base_parser::parent_scope_info::name_ok (const std::string& name)
  {
    // Name can't be the same as any parent function or any other
    // function we've already seen.  We could maintain a complex
    // tree structure of names, or we can just store the set of
    // full names of all the functions, which must be unique.

    std::string full_name;

    for (size_t i = 0; i < size()-1; i++)
      {
        const value_type& elt = m_info[i];

        if (name == elt.second)
          return false;

        full_name += elt.second + ">";
      }

    full_name += name;

    if (m_all_names.find (full_name) != m_all_names.end ())
      return false;

    m_all_names.insert (full_name);

    return true;
  }

  bool
  base_parser::parent_scope_info::name_current_scope (const std::string& name)
  {
    if (! name_ok (name))
      return false;

    if (size () > 0)
      m_info.back().second = name;

    return true;
  }

  symbol_scope
  base_parser::parent_scope_info::parent_scope (void) const
  {
    return size () > 1 ? m_info[size()-2].first : symbol_scope ();
  }

  std::string
  base_parser::parent_scope_info::parent_name (void) const
  {
    return m_info[size()-2].second;
  }

  void base_parser::parent_scope_info::clear (void)
  {
    m_info.clear ();
    m_all_names.clear ();
  }

  base_parser::base_parser (base_lexer& lxr)
    : m_endfunction_found (false), m_autoloading (false),
      m_fcn_file_from_relative_lookup (false),
      m_parsing_subfunctions (false), m_parsing_local_functions (false),
      m_max_fcn_depth (-1), m_curr_fcn_depth (-1), m_primary_fcn_scope (),
      m_curr_class_name (), m_curr_package_name (), m_function_scopes (),
      m_primary_fcn (), m_subfunction_names (), m_classdef_object (),
      m_stmt_list (), m_lexer (lxr), m_parser_state (yypstate_new ())
  { }

  base_parser::~base_parser (void)
  {
    delete &m_lexer;

    // FIXME: Deleting the internal Bison parser state structure does
    // not clean up any partial parse trees in the event of an interrupt or
    // error.  It's not clear how to safely do that with the C language
    // parser that Bison generates.  The C++ language parser that Bison
    // generates would do it for us automatically whenever an exception
    // is thrown while parsing input, but there is currently no C++
    // interface for a push parser.

    yypstate_delete (static_cast<yypstate *> (m_parser_state));
  }

  void
  base_parser::reset (void)
  {
    m_endfunction_found = false;
    m_autoloading = false;
    m_fcn_file_from_relative_lookup = false;
    m_parsing_subfunctions = false;
    m_parsing_local_functions = false;
    m_max_fcn_depth = -1;
    m_curr_fcn_depth = -1;
    m_primary_fcn_scope = symbol_scope ();
    m_curr_class_name = "";
    m_curr_package_name = "";
    m_function_scopes.clear ();
    m_primary_fcn = octave_value ();
    m_subfunction_names.clear ();
    m_classdef_object.reset ();
    m_stmt_list.reset ();

    m_lexer.reset ();

    yypstate_delete (static_cast<yypstate *> (m_parser_state));
    m_parser_state = yypstate_new ();
  }

  // Error messages for mismatched end tokens.

  static std::string
  end_token_as_string (token::end_tok_type ettype)
  {
    std::string retval = "<unknown>";

    switch (ettype)
      {
      case token::simple_end:
        retval = "end";
        break;

      case token::classdef_end:
        retval = "endclassdef";
        break;

      case token::enumeration_end:
        retval = "endenumeration";
        break;

      case token::events_end:
        retval = "endevents";
        break;

      case token::for_end:
        retval = "endfor";
        break;

      case token::function_end:
        retval = "endfunction";
        break;

      case token::if_end:
        retval = "endif";
        break;

      case token::methods_end:
        retval = "endmethods";
        break;

      case token::parfor_end:
        retval = "endparfor";
        break;

      case token::properties_end:
        retval = "endproperties";
        break;

      case token::switch_end:
        retval = "endswitch";
        break;

      case token::try_catch_end:
        retval = "end_try_catch";
        break;

      case token::unwind_protect_end:
        retval = "end_unwind_protect";
        break;

      case token::while_end:
        retval = "endwhile";
        break;

      default:
        panic_impossible ();
        break;
      }

    return retval;
  }

  void
  base_parser::end_token_error (token *tok, token::end_tok_type expected)
  {
    std::string msg = ("'" + end_token_as_string (expected)
                       + "' command matched by '"
                       + end_token_as_string (tok->ettype ()) + "'");

    bison_error (msg, tok->beg_pos ());
  }

  // Check to see that end tokens are properly matched.

  bool
  base_parser::end_token_ok (token *tok, token::end_tok_type expected)
  {
    token::end_tok_type ettype = tok->ettype ();

    return ettype == expected || ettype == token::simple_end;
  }

  bool
  base_parser::push_fcn_symtab (void)
  {
    m_curr_fcn_depth++;

    if (m_max_fcn_depth < m_curr_fcn_depth)
      m_max_fcn_depth = m_curr_fcn_depth;

    // Will get a real name later.
    m_lexer.m_symtab_context.push (octave::symbol_scope ("parser:push_fcn_symtab"));
    m_function_scopes.push (m_lexer.m_symtab_context.curr_scope ());

    if (! m_lexer.m_reading_script_file && m_curr_fcn_depth == 0
        && ! m_parsing_subfunctions)
      m_primary_fcn_scope = m_lexer.m_symtab_context.curr_scope ();

    if (m_lexer.m_reading_script_file && m_curr_fcn_depth > 0)
      {
        bison_error ("nested functions not implemented in this context");

        return false;
      }

    return true;
  }

  // Make a constant.

  tree_constant *
  base_parser::make_constant (int op, token *tok_val)
  {
    int l = tok_val->line ();
    int c = tok_val->column ();

    tree_constant *retval = nullptr;

    switch (op)
      {
      case NUM:
        {
          octave_value tmp (tok_val->number ());
          retval = new tree_constant (tmp, l, c);
          retval->stash_original_text (tok_val->text_rep ());
        }
        break;

      case IMAG_NUM:
        {
          octave_value tmp (Complex (0.0, tok_val->number ()));
          retval = new tree_constant (tmp, l, c);
          retval->stash_original_text (tok_val->text_rep ());
        }
        break;

      case DQ_STRING:
      case SQ_STRING:
        {
          std::string txt = tok_val->text ();

          char delim = op == DQ_STRING ? '"' : '\'';
          octave_value tmp (txt, delim);

          if (txt.empty ())
            {
              if (op == DQ_STRING)
                tmp = octave_null_str::instance;
              else
                tmp = octave_null_sq_str::instance;
            }

          retval = new tree_constant (tmp, l, c);

          if (op == DQ_STRING)
            txt = undo_string_escapes (txt);

          // FIXME: maybe this should also be handled by
          // tok_val->text_rep () for character strings?
          retval->stash_original_text (delim + txt + delim);
        }
        break;

      default:
        panic_impossible ();
        break;
      }

    return retval;
  }

  // Make a function handle.

  tree_fcn_handle *
  base_parser::make_fcn_handle (token *tok_val)
  {
    int l = tok_val->line ();
    int c = tok_val->column ();

    tree_fcn_handle *retval = new tree_fcn_handle (tok_val->text (), l, c);

    return retval;
  }

  // Make an anonymous function handle.

  tree_anon_fcn_handle *
  base_parser::make_anon_fcn_handle (tree_parameter_list *param_list,
                                     tree_expression *expr,
                                     const filepos& at_pos)
  {
    // FIXME: We need to examine EXPR and issue an error if any
    // sub-expression contains an assignment, compound assignment,
    // increment, or decrement operator.

    anon_fcn_validator validator (param_list, expr);

    if (! validator.ok ())
      {
        delete param_list;
        delete expr;

        bison_error (validator.message (), validator.line (),
                     validator.column ());

        return nullptr;
      }

    symbol_scope fcn_scope = m_lexer.m_symtab_context.curr_scope ();
    symbol_scope parent_scope = m_lexer.m_symtab_context.parent_scope ();

    m_lexer.m_symtab_context.pop ();

    expr->set_print_flag (false);

    fcn_scope.mark_static ();

    int at_line = at_pos.line ();
    int at_column = at_pos.column ();

    tree_anon_fcn_handle *retval
      = new tree_anon_fcn_handle (param_list, expr, fcn_scope,
                                  parent_scope, at_line, at_column);

    std::ostringstream buf;

    tree_print_code tpc (buf);

    retval->accept (tpc);

    std::string file = m_lexer.m_fcn_file_full_name;
    if (! file.empty ())
      buf << ": file: " << file;
    else if (m_lexer.input_from_terminal ())
      buf << ": *terminal input*";
    else if (m_lexer.input_from_eval_string ())
      buf << ": *eval string*";
    buf << ": line: " << at_line << " column: " << at_column;

    std::string scope_name = buf.str ();

    fcn_scope.cache_name (scope_name);

    // FIXME: Stash the filename.  This does not work and produces
    // errors when executed.
    //retval->stash_file_name (m_lexer.m_fcn_file_name);

    return retval;
  }

  // Build a colon expression.

  tree_expression *
  base_parser::make_colon_expression (tree_expression *base,
                                      tree_expression *limit,
                                      tree_expression *incr)
  {
    tree_expression *retval = nullptr;

    if (! base || ! limit)
      {
        delete base;
        delete limit;
        delete incr;

        return retval;
      }

    int l = base->line ();
    int c = base->column ();

    tree_colon_expression *expr
      = new tree_colon_expression (base, limit, incr, l, c);

    retval = expr;

    if (base->is_constant () && limit->is_constant ()
        && (! incr || incr->is_constant ()))
      {
        interpreter& interp = __get_interpreter__ ("finish_colon_expression");

        try
          {
            // If the evaluation generates a warning message, restore
            // the previous value of last_warning_message and skip the
            // conversion to a constant value.

            unwind_protect frame;

            error_system& es = interp.get_error_system ();

            frame.add_method (es, &error_system::set_last_warning_message,
                              es.last_warning_message (""));

            frame.add_method (es, &error_system::set_discard_warning_messages,
                              es.discard_warning_messages (true));

            tree_evaluator& tw = interp.get_evaluator ();

            octave_value tmp = expr->evaluate (tw);

            std::string msg = es.last_warning_message ();

            if (msg.empty ())
              {
                tree_constant *tc_retval
                  = new tree_constant (tmp, expr->line (), expr->column ());

                std::ostringstream buf;

                tree_print_code tpc (buf);

                expr->accept (tpc);

                tc_retval->stash_original_text (buf.str ());

                delete expr;

                retval = tc_retval;
              }
          }
        catch (const execution_exception&)
          {
            interp.recover_from_exception ();
          }
      }

    return retval;
  }

  // Build a binary expression.

  tree_expression *
  base_parser::make_binary_op (int op, tree_expression *op1,
                               token *tok_val, tree_expression *op2)
  {
    octave_value::binary_op t = octave_value::unknown_binary_op;

    switch (op)
      {
      case POW:
        t = octave_value::op_pow;
        break;

      case EPOW:
        t = octave_value::op_el_pow;
        break;

      case '+':
        t = octave_value::op_add;
        break;

      case '-':
        t = octave_value::op_sub;
        break;

      case '*':
        t = octave_value::op_mul;
        break;

      case '/':
        t = octave_value::op_div;
        break;

      case EMUL:
        t = octave_value::op_el_mul;
        break;

      case EDIV:
        t = octave_value::op_el_div;
        break;

      case LEFTDIV:
        t = octave_value::op_ldiv;
        break;

      case ELEFTDIV:
        t = octave_value::op_el_ldiv;
        break;

      case EXPR_LT:
        t = octave_value::op_lt;
        break;

      case EXPR_LE:
        t = octave_value::op_le;
        break;

      case EXPR_EQ:
        t = octave_value::op_eq;
        break;

      case EXPR_GE:
        t = octave_value::op_ge;
        break;

      case EXPR_GT:
        t = octave_value::op_gt;
        break;

      case EXPR_NE:
        t = octave_value::op_ne;
        break;

      case EXPR_AND:
        t = octave_value::op_el_and;
        break;

      case EXPR_OR:
        t = octave_value::op_el_or;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = tok_val->line ();
    int c = tok_val->column ();

    return maybe_compound_binary_expression (op1, op2, l, c, t);
  }

  // Build a boolean expression.

  tree_expression *
  base_parser::make_boolean_op (int op, tree_expression *op1,
                                token *tok_val, tree_expression *op2)
  {
    tree_boolean_expression::type t;

    switch (op)
      {
      case EXPR_AND_AND:
        t = tree_boolean_expression::bool_and;
        break;

      case EXPR_OR_OR:
        t = tree_boolean_expression::bool_or;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = tok_val->line ();
    int c = tok_val->column ();

    return new tree_boolean_expression (op1, op2, l, c, t);
  }

  // Build a prefix expression.

  tree_expression *
  base_parser::make_prefix_op (int op, tree_expression *op1, token *tok_val)
  {
    octave_value::unary_op t = octave_value::unknown_unary_op;

    switch (op)
      {
      case EXPR_NOT:
        t = octave_value::op_not;
        break;

      case '+':
        t = octave_value::op_uplus;
        break;

      case '-':
        t = octave_value::op_uminus;
        break;

      case PLUS_PLUS:
        t = octave_value::op_incr;
        break;

      case MINUS_MINUS:
        t = octave_value::op_decr;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = tok_val->line ();
    int c = tok_val->column ();

    return new tree_prefix_expression (op1, l, c, t);
  }

  // Build a postfix expression.

  tree_expression *
  base_parser::make_postfix_op (int op, tree_expression *op1, token *tok_val)
  {
    octave_value::unary_op t = octave_value::unknown_unary_op;

    switch (op)
      {
      case HERMITIAN:
        t = octave_value::op_hermitian;
        break;

      case TRANSPOSE:
        t = octave_value::op_transpose;
        break;

      case PLUS_PLUS:
        t = octave_value::op_incr;
        break;

      case MINUS_MINUS:
        t = octave_value::op_decr;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = tok_val->line ();
    int c = tok_val->column ();

    return new tree_postfix_expression (op1, l, c, t);
  }

  // Build an unwind-protect command.

  tree_command *
  base_parser::make_unwind_command (token *unwind_tok,
                                    tree_statement_list *body,
                                    tree_statement_list *cleanup_stmts,
                                    token *end_tok,
                                    comment_list *lc,
                                    comment_list *mc)
  {
    tree_command *retval = nullptr;

    if (end_token_ok (end_tok, token::unwind_protect_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = unwind_tok->line ();
        int c = unwind_tok->column ();

        retval = new tree_unwind_protect_command (body, cleanup_stmts,
                                                  lc, mc, tc, l, c);
      }
    else
      {
        delete body;
        delete cleanup_stmts;

        end_token_error (end_tok, token::unwind_protect_end);
      }

    return retval;
  }

  // Build a try-catch command.

  tree_command *
  base_parser::make_try_command (token *try_tok,
                                 tree_statement_list *body,
                                 char catch_sep,
                                 tree_statement_list *cleanup_stmts,
                                 token *end_tok,
                                 comment_list *lc,
                                 comment_list *mc)
  {
    tree_command *retval = nullptr;

    if (end_token_ok (end_tok, token::try_catch_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = try_tok->line ();
        int c = try_tok->column ();

        tree_identifier *id = nullptr;

        if (! catch_sep && cleanup_stmts && ! cleanup_stmts->empty ())
          {
            tree_statement *stmt = cleanup_stmts->front ();

            if (stmt)
              {
                tree_expression *expr = stmt->expression ();

                if (expr && expr->is_identifier ())
                  {
                    id = dynamic_cast<tree_identifier *> (expr);

                    cleanup_stmts->pop_front ();

                    stmt->set_expression (nullptr);
                    delete stmt;
                  }
              }
          }

        retval = new tree_try_catch_command (body, cleanup_stmts, id,
                                             lc, mc, tc, l, c);
      }
    else
      {
        delete body;
        delete cleanup_stmts;

        end_token_error (end_tok, token::try_catch_end);
      }

    return retval;
  }

  // Build a while command.

  tree_command *
  base_parser::make_while_command (token *while_tok,
                                   tree_expression *expr,
                                   tree_statement_list *body,
                                   token *end_tok,
                                   comment_list *lc)
  {
    tree_command *retval = nullptr;

    maybe_warn_assign_as_truth_value (expr);

    if (end_token_ok (end_tok, token::while_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        m_lexer.m_looping--;

        int l = while_tok->line ();
        int c = while_tok->column ();

        retval = new tree_while_command (expr, body, lc, tc, l, c);
      }
    else
      {
        delete expr;
        delete body;

        end_token_error (end_tok, token::while_end);
      }

    return retval;
  }

  // Build a do-until command.

  tree_command *
  base_parser::make_do_until_command (token *until_tok,
                                      tree_statement_list *body,
                                      tree_expression *expr,
                                      comment_list *lc)
  {
    maybe_warn_assign_as_truth_value (expr);

    comment_list *tc = m_lexer.m_comment_buf.get_comment ();

    m_lexer.m_looping--;

    int l = until_tok->line ();
    int c = until_tok->column ();

    return new tree_do_until_command (expr, body, lc, tc, l, c);
  }

  // Build a for command.

  tree_command *
  base_parser::make_for_command (int tok_id, token *for_tok,
                                 tree_argument_list *lhs,
                                 tree_expression *expr,
                                 tree_expression *maxproc,
                                 tree_statement_list *body,
                                 token *end_tok,
                                 comment_list *lc)
  {
    tree_command *retval = nullptr;

    bool parfor = tok_id == PARFOR;

    if (end_token_ok (end_tok, parfor ? token::parfor_end : token::for_end))
      {
        expr->mark_as_for_cmd_expr ();

        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        m_lexer.m_looping--;

        int l = for_tok->line ();
        int c = for_tok->column ();

        if (lhs->length () == 1)
          {
            tree_expression *tmp = lhs->remove_front ();

            retval = new tree_simple_for_command (parfor, tmp, expr, maxproc,
                                                  body, lc, tc, l, c);

            delete lhs;
          }
        else
          {
            if (parfor)
              {
                delete lhs;
                delete expr;
                delete maxproc;
                delete body;

                bison_error ("invalid syntax for parfor statement");
              }
            else
              retval = new tree_complex_for_command (lhs, expr, body,
                                                     lc, tc, l, c);
          }
      }
    else
      {
        delete lhs;
        delete expr;
        delete maxproc;
        delete body;

        end_token_error (end_tok, parfor ? token::parfor_end : token::for_end);
      }

    return retval;
  }

  // Build a break command.

  tree_command *
  base_parser::make_break_command (token *break_tok)
  {
    int l = break_tok->line ();
    int c = break_tok->column ();

    if (! m_lexer.m_looping)
      {
        bison_error ("break must appear within a loop");
        return nullptr;
      }
    else
      return new tree_break_command (l, c);
  }

  // Build a continue command.

  tree_command *
  base_parser::make_continue_command (token *continue_tok)
  {
    int l = continue_tok->line ();
    int c = continue_tok->column ();

    if (! m_lexer.m_looping)
      {
        bison_error ("continue must appear within a loop");
        return nullptr;
      }
    else
      return new tree_continue_command (l, c);
  }

  // Build a return command.

  tree_command *
  base_parser::make_return_command (token *return_tok)
  {
    int l = return_tok->line ();
    int c = return_tok->column ();

    return new tree_return_command (l, c);
  }

  // Start an if command.

  tree_if_command_list *
  base_parser::start_if_command (tree_expression *expr,
                                 tree_statement_list *list)
  {
    maybe_warn_assign_as_truth_value (expr);

    tree_if_clause *t = new tree_if_clause (expr, list);

    return new tree_if_command_list (t);
  }

  // Finish an if command.

  tree_if_command *
  base_parser::finish_if_command (token *if_tok,
                                  tree_if_command_list *list,
                                  token *end_tok,
                                  comment_list *lc)
  {
    tree_if_command *retval = nullptr;

    if (end_token_ok (end_tok, token::if_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = if_tok->line ();
        int c = if_tok->column ();

        if (list && ! list->empty ())
          {
            tree_if_clause *elt = list->front ();

            if (elt)
              {
                elt->line (l);
                elt->column (c);
              }
          }

        retval = new tree_if_command (list, lc, tc, l, c);
      }
    else
      {
        delete list;

        end_token_error (end_tok, token::if_end);
      }

    return retval;
  }

  // Build an elseif clause.

  tree_if_clause *
  base_parser::make_elseif_clause (token *elseif_tok,
                                   tree_expression *expr,
                                   tree_statement_list *list,
                                   comment_list *lc)
  {
    maybe_warn_assign_as_truth_value (expr);

    int l = elseif_tok->line ();
    int c = elseif_tok->column ();

    return new tree_if_clause (expr, list, lc, l, c);
  }

  // Finish a switch command.

  tree_switch_command *
  base_parser::finish_switch_command (token *switch_tok,
                                      tree_expression *expr,
                                      tree_switch_case_list *list,
                                      token *end_tok,
                                      comment_list *lc)
  {
    tree_switch_command *retval = nullptr;

    if (end_token_ok (end_tok, token::switch_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = switch_tok->line ();
        int c = switch_tok->column ();

        if (list && ! list->empty ())
          {
            tree_switch_case *elt = list->front ();

            if (elt)
              {
                elt->line (l);
                elt->column (c);
              }
          }

        retval = new tree_switch_command (expr, list, lc, tc, l, c);
      }
    else
      {
        delete expr;
        delete list;

        end_token_error (end_tok, token::switch_end);
      }

    return retval;
  }

  // Build a switch case.

  tree_switch_case *
  base_parser::make_switch_case (token *case_tok,
                                 tree_expression *expr,
                                 tree_statement_list *list,
                                 comment_list *lc)
  {
    maybe_warn_variable_switch_label (expr);

    int l = case_tok->line ();
    int c = case_tok->column ();

    return new tree_switch_case (expr, list, lc, l, c);
  }

  // Build an assignment to a variable.

  tree_expression *
  base_parser::make_assign_op (int op, tree_argument_list *lhs,
                               token *eq_tok, tree_expression *rhs)
  {
    octave_value::assign_op t = octave_value::unknown_assign_op;

    switch (op)
      {
      case '=':
        t = octave_value::op_asn_eq;
        break;

      case ADD_EQ:
        t = octave_value::op_add_eq;
        break;

      case SUB_EQ:
        t = octave_value::op_sub_eq;
        break;

      case MUL_EQ:
        t = octave_value::op_mul_eq;
        break;

      case DIV_EQ:
        t = octave_value::op_div_eq;
        break;

      case LEFTDIV_EQ:
        t = octave_value::op_ldiv_eq;
        break;

      case POW_EQ:
        t = octave_value::op_pow_eq;
        break;

      case EMUL_EQ:
        t = octave_value::op_el_mul_eq;
        break;

      case EDIV_EQ:
        t = octave_value::op_el_div_eq;
        break;

      case ELEFTDIV_EQ:
        t = octave_value::op_el_ldiv_eq;
        break;

      case EPOW_EQ:
        t = octave_value::op_el_pow_eq;
        break;

      case AND_EQ:
        t = octave_value::op_el_and_eq;
        break;

      case OR_EQ:
        t = octave_value::op_el_or_eq;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = eq_tok->line ();
    int c = eq_tok->column ();

    if (! lhs->is_simple_assign_lhs () && t != octave_value::op_asn_eq)
      {
        // Multiple assignments like [x,y] OP= rhs are only valid for
        // '=', not '+=', etc.

        delete lhs;
        delete rhs;

        bison_error ("computed multiple assignment not allowed",
                     eq_tok->beg_pos ());

        return nullptr;
      }

    if (lhs->is_simple_assign_lhs ())
      {
        // We are looking at a simple assignment statement like x = rhs;

        tree_expression *tmp = lhs->remove_front ();

        if ((tmp->is_identifier () || tmp->is_index_expression ())
            && iskeyword (tmp->name ()))
          {
            std::string kw = tmp->name ();

            delete tmp;
            delete lhs;
            delete rhs;

            bison_error ("invalid assignment to keyword \"" + kw + "\"",
                         eq_tok->beg_pos ());

            return nullptr;
          }

        delete lhs;

        return new tree_simple_assignment (tmp, rhs, false, l, c, t);
      }
    else
      {
        std::list<std::string> names = lhs->variable_names ();

        for (const auto& kw : names)
          {
            if (iskeyword (kw))
              {
                delete lhs;
                delete rhs;

                bison_error ("invalid assignment to keyword \"" + kw + "\"",
                             eq_tok->beg_pos ());

                return nullptr;
              }
          }

        return new tree_multi_assignment (lhs, rhs, false, l, c);
      }
  }

  // Define a script.

  void
  base_parser::make_script (tree_statement_list *cmds,
                            tree_statement *end_script)
  {
    if (! cmds)
      cmds = new tree_statement_list ();

    cmds->append (end_script);

    symbol_scope script_scope = m_lexer.m_symtab_context.curr_scope ();

    script_scope.cache_name (m_lexer.m_fcn_file_full_name);
    script_scope.cache_fcn_file_name (m_lexer.m_fcn_file_full_name);
    script_scope.cache_dir_name (m_lexer.m_dir_name);

    octave_user_script *script
      = new octave_user_script (m_lexer.m_fcn_file_full_name,
                                m_lexer.m_fcn_file_name, script_scope,
                                cmds, m_lexer.m_help_text);

    m_lexer.m_symtab_context.pop ();
    m_lexer.m_help_text = "";

    sys::time now;

    script->stash_fcn_file_time (now);
    script->stash_dir_name (m_lexer.m_dir_name);

    m_primary_fcn = octave_value (script);
  }

  tree_identifier *
  base_parser::make_fcn_name (tree_identifier *id)
  {
    std::string id_name = id->name ();

    // Make classdef local functions unique from classdef methods.

    if (m_parsing_local_functions && m_curr_fcn_depth == 0)
      id_name = m_lexer.m_fcn_file_name + ">" + id_name;

    if (! m_function_scopes.name_current_scope (id_name))
      {
        bison_error ("duplicate subfunction or nested function name",
                     id->line (), id->column ());

        delete id;
        return nullptr;
      }

    octave::symbol_scope curr_scope = m_lexer.m_symtab_context.curr_scope ();
    curr_scope.cache_name (id_name);

    m_lexer.m_parsed_function_name.top () = true;
    m_lexer.m_maybe_classdef_get_set_method = false;

    return id;
  }

  // Define a function.

  // FIXME: combining start_function, finish_function, and
  // recover_from_parsing_function should be possible, but it makes
  // for a large mess.  Maybe this could be a bit better organized?

  tree_function_def *
  base_parser::make_function (token *fcn_tok,
                              tree_parameter_list *ret_list,
                              tree_identifier *id,
                              tree_parameter_list *param_list,
                              tree_statement_list *body,
                              tree_statement *end_fcn_stmt,
                              comment_list *lc)
  {
    int l = fcn_tok->line ();
    int c = fcn_tok->column ();

    octave_user_function *tmp_fcn
      = start_function (id, param_list, body, end_fcn_stmt);

    tree_function_def *retval = finish_function (ret_list, tmp_fcn, lc, l, c);

    recover_from_parsing_function ();

    return retval;
  }

  // Begin defining a function.

  octave_user_function *
  base_parser::start_function (tree_identifier *id,
                               tree_parameter_list *param_list,
                               tree_statement_list *body,
                               tree_statement *end_fcn_stmt)
  {
    // We'll fill in the return list later.

    std::string id_name = id->name ();

    delete id;

    if (m_lexer.m_parsing_classdef_get_method)
      id_name.insert (0, "get.");
    else if (m_lexer.m_parsing_classdef_set_method)
      id_name.insert (0, "set.");

    m_lexer.m_parsing_classdef_get_method = false;
    m_lexer.m_parsing_classdef_set_method = false;

    if (! body)
      body = new tree_statement_list ();

    body->append (end_fcn_stmt);

    octave_user_function *fcn
      = new octave_user_function (m_lexer.m_symtab_context.curr_scope (),
                                  param_list, nullptr, body);

    comment_list *tc = m_lexer.m_comment_buf.get_comment ();

    fcn->stash_trailing_comment (tc);
    fcn->stash_fcn_end_location (end_fcn_stmt->line (),
                                 end_fcn_stmt->column ());

    // If input is coming from a file, issue a warning if the name of
    // the file does not match the name of the function stated in the
    // file.  Matlab doesn't provide a diagnostic (it ignores the stated
    // name).
    if (! m_autoloading && m_lexer.m_reading_fcn_file
        && m_curr_fcn_depth == 0 && ! m_parsing_subfunctions)
      {
        // FIXME: should m_lexer.m_fcn_file_name already be
        // preprocessed when we get here?  It seems to only be a
        // problem with relative filenames.

        std::string nm = m_lexer.m_fcn_file_name;

        size_t pos = nm.find_last_of (sys::file_ops::dir_sep_chars ());

        if (pos != std::string::npos)
          nm = m_lexer.m_fcn_file_name.substr (pos+1);

        if (nm != id_name)
          {
            warning_with_id
              ("Octave:function-name-clash",
               "function name '%s' does not agree with function filename '%s'",
               id_name.c_str (), m_lexer.m_fcn_file_full_name.c_str ());

            id_name = nm;
          }
      }

    if (m_lexer.m_reading_fcn_file || m_lexer.m_reading_classdef_file || m_autoloading)
      {
        sys::time now;

        fcn->stash_fcn_file_name (m_lexer.m_fcn_file_full_name);
        fcn->stash_fcn_file_time (now);
        fcn->stash_dir_name (m_lexer.m_dir_name);
        fcn->stash_package_name (m_lexer.m_package_name);
        fcn->mark_as_system_fcn_file ();

        if (m_fcn_file_from_relative_lookup)
          fcn->mark_relative ();

        if (m_lexer.m_parsing_class_method)
          {
            if (m_lexer.m_parsing_classdef)
              {
                if (m_curr_class_name == id_name)
                  fcn->mark_as_classdef_constructor ();
                else
                  fcn->mark_as_classdef_method ();
              }
            else
              {
                if (m_curr_class_name == id_name)
                  fcn->mark_as_legacy_constructor ();
                else
                  fcn->mark_as_legacy_method ();
              }

            fcn->stash_dispatch_class (m_curr_class_name);
          }

        std::string nm = fcn->fcn_file_name ();

        sys::file_stat fs (nm);

        if (fs && fs.is_newer (now))
          warning_with_id ("Octave:future-time-stamp",
                           "time stamp for '%s' is in the future", nm.c_str ());
      }
    else if (! m_lexer.input_from_tmp_history_file ()
             && ! m_lexer.m_force_script
             && m_lexer.m_reading_script_file
             && m_lexer.m_fcn_file_name == id_name)
      {
        warning ("function '%s' defined within script file '%s'",
                 id_name.c_str (), m_lexer.m_fcn_file_full_name.c_str ());
      }

    fcn->stash_function_name (id_name);

    // Record help text for functions other than nested functions.
    // We cannot currently record help for nested functions (bug #46008)
    // because the doc_string of the outermost function is read first,
    // whereas this function is called for the innermost function first.
    // We could have a stack of help_text in lexer.
    if (! m_lexer.m_help_text.empty () && m_curr_fcn_depth == 0)
      {
        fcn->document (m_lexer.m_help_text);

        m_lexer.m_help_text = "";
      }

    if (m_lexer.m_reading_fcn_file && m_curr_fcn_depth == 0
        && ! m_parsing_subfunctions)
      m_primary_fcn = octave_value (fcn);

    return fcn;
  }

  tree_statement *
  base_parser::make_end (const std::string& type, bool eof,
                         const filepos& beg_pos, const filepos& /*end_pos*/)
  {
    int l = beg_pos.line ();
    int c = beg_pos.column ();

    return make_statement (new tree_no_op_command (type, eof, l, c));
  }

  tree_function_def *
  base_parser::finish_function (tree_parameter_list *ret_list,
                                octave_user_function *fcn,
                                comment_list *lc,
                                int l, int c)
  {
    tree_function_def *retval = nullptr;

    if (ret_list)
      ret_list->mark_as_formal_parameters ();

    if (fcn)
      {
        std::string nm = fcn->name ();
        std::string file = fcn->fcn_file_name ();

        std::string tmp = nm;
        if (! file.empty ())
          tmp += ": " + file;

        symbol_scope fcn_scope = fcn->scope ();
        fcn_scope.cache_name (tmp);
        fcn_scope.cache_fcn_file_name (file);
        fcn_scope.cache_dir_name (m_lexer.m_dir_name);

        if (lc)
          fcn->stash_leading_comment (lc);

        fcn->define_ret_list (ret_list);

        if (m_curr_fcn_depth > 0 || m_parsing_subfunctions)
          {
            fcn->stash_fcn_location (l, c);
            fcn->stash_parent_fcn_name (m_lexer.m_fcn_file_name);

            octave_value ov_fcn (fcn);

            if (m_endfunction_found && m_function_scopes.size () > 1)
              {
                fcn->mark_as_nested_function ();
                fcn_scope.set_nesting_depth (m_curr_fcn_depth);

                symbol_scope pscope = m_function_scopes.parent_scope ();
                fcn_scope.set_parent (pscope);
                fcn_scope.set_primary_parent (m_primary_fcn_scope);
                pscope.install_nestfunction (nm, ov_fcn, fcn_scope);
              }
            else
              {
                fcn->mark_as_subfunction ();
                m_subfunction_names.push_back (nm);
                fcn_scope.set_parent (m_primary_fcn_scope);
                m_primary_fcn_scope.install_subfunction (nm, ov_fcn);
              }
          }

        if (m_curr_fcn_depth == 0)
          fcn_scope.update_nest ();

        if (! m_lexer.m_reading_fcn_file && m_curr_fcn_depth == 0)
          {
            // We are either reading a script file or defining a function
            // at the command line, so this definition creates a
            // tree_function object that is placed in the parse tree.
            // Otherwise, it is just inserted in the symbol table,
            // either as a subfunction or nested function (see above),
            // or as the primary function for the file, via
            // m_primary_fcn (see also load_fcn_from_file,,
            // parse_fcn_file, and
            // fcn_info::fcn_info_rep::find_user_function).

            if (m_lexer.m_buffer_function_text)
              {
                fcn->cache_function_text (m_lexer.m_function_text,
                                          fcn->time_parsed ());
                m_lexer.m_buffer_function_text = false;
              }

            retval = new tree_function_def (fcn);
          }
      }

    return retval;
  }

  void
  base_parser::recover_from_parsing_function (void)
  {
    m_lexer.m_symtab_context.pop ();

    if (m_lexer.m_reading_fcn_file && m_curr_fcn_depth == 0
        && ! m_parsing_subfunctions)
      m_parsing_subfunctions = true;

    m_curr_fcn_depth--;
    m_function_scopes.pop ();

    m_lexer.m_defining_func--;
    m_lexer.m_parsed_function_name.pop ();
    m_lexer.m_looking_at_return_list = false;
    m_lexer.m_looking_at_parameter_list = false;
  }

  // A CLASSDEF block defines a class that has a constructor and other
  // methods, but it is not an executable command.  Parsing the block
  // makes some changes in the symbol table (inserting the constructor
  // and methods, and adding to the list of known objects) and creates
  // a parse tree containing meta information about the class.

  tree_classdef *
  base_parser::make_classdef (token *tok_val,
                              tree_classdef_attribute_list *a,
                              tree_identifier *id,
                              tree_classdef_superclass_list *sc,
                              tree_classdef_body *body, token *end_tok,
                              comment_list *lc)
  {
    tree_classdef *retval = nullptr;

    m_lexer.m_symtab_context.pop ();

    std::string cls_name = id->name ();

    std::string nm = m_lexer.m_fcn_file_name;

    size_t pos = nm.find_last_of (sys::file_ops::dir_sep_chars ());

    if (pos != std::string::npos)
      nm = m_lexer.m_fcn_file_name.substr (pos+1);

    if (nm != cls_name)
      {
        int l = id->line ();
        int c = id->column ();

        delete a;
        delete id;
        delete sc;
        delete body;

        bison_error ("invalid classdef definition, the class name must match the filename", l, c);

      }
    else
      {
        if (end_token_ok (end_tok, token::classdef_end))
          {
            comment_list *tc = m_lexer.m_comment_buf.get_comment ();

            int l = tok_val->line ();
            int c = tok_val->column ();

            if (! body)
              body = new tree_classdef_body ();

            retval = new tree_classdef (m_lexer.m_symtab_context.curr_scope (),
                                        a, id, sc, body, lc, tc,
                                        m_curr_package_name, l, c);
          }
        else
          {
            delete a;
            delete id;
            delete sc;
            delete body;

            end_token_error (end_tok, token::switch_end);
          }
      }

    return retval;
  }

  tree_classdef_properties_block *
  base_parser::make_classdef_properties_block (token *tok_val,
                                               tree_classdef_attribute_list *a,
                                               tree_classdef_property_list *plist,
                                               token *end_tok,
                                               comment_list *lc)
  {
    tree_classdef_properties_block *retval = nullptr;

    if (end_token_ok (end_tok, token::properties_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = tok_val->line ();
        int c = tok_val->column ();

        if (! plist)
          plist = new tree_classdef_property_list ();

        retval = new tree_classdef_properties_block (a, plist, lc, tc, l, c);
      }
    else
      {
        delete a;
        delete plist;

        end_token_error (end_tok, token::properties_end);
      }

    return retval;
  }

  tree_classdef_methods_block *
  base_parser::make_classdef_methods_block (token *tok_val,
                                            tree_classdef_attribute_list *a,
                                            tree_classdef_methods_list *mlist,
                                            token *end_tok,
                                            comment_list *lc)
  {
    tree_classdef_methods_block *retval = nullptr;

    if (end_token_ok (end_tok, token::methods_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = tok_val->line ();
        int c = tok_val->column ();

        if (! mlist)
          mlist = new tree_classdef_methods_list ();

        retval = new tree_classdef_methods_block (a, mlist, lc, tc, l, c);
      }
    else
      {
        delete a;
        delete mlist;

        end_token_error (end_tok, token::methods_end);
      }

    return retval;
  }

  tree_classdef_events_block *
  base_parser::make_classdef_events_block (token *tok_val,
                                           tree_classdef_attribute_list *a,
                                           tree_classdef_events_list *elist,
                                           token *end_tok,
                                           comment_list *lc)
  {
    tree_classdef_events_block *retval = nullptr;

    if (end_token_ok (end_tok, token::events_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = tok_val->line ();
        int c = tok_val->column ();

        if (! elist)
          elist = new tree_classdef_events_list ();

        retval = new tree_classdef_events_block (a, elist, lc, tc, l, c);
      }
    else
      {
        delete a;
        delete elist;

        end_token_error (end_tok, token::events_end);
      }

    return retval;
  }

  tree_classdef_enum_block *
  base_parser::make_classdef_enum_block (token *tok_val,
                                         tree_classdef_attribute_list *a,
                                         tree_classdef_enum_list *elist,
                                         token *end_tok,
                                         comment_list *lc)
  {
    tree_classdef_enum_block *retval = nullptr;

    if (end_token_ok (end_tok, token::enumeration_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = tok_val->line ();
        int c = tok_val->column ();

        if (! elist)
          elist = new tree_classdef_enum_list ();

        retval = new tree_classdef_enum_block (a, elist, lc, tc, l, c);
      }
    else
      {
        delete a;
        delete elist;

        end_token_error (end_tok, token::enumeration_end);
      }

    return retval;
  }

  octave_user_function*
  base_parser::start_classdef_external_method (tree_identifier *id,
                                               tree_parameter_list *pl)
  {
    octave_user_function* retval = nullptr;

    // External methods are only allowed within @-folders. In this case,
    // m_curr_class_name will be non-empty.

    if (! m_curr_class_name.empty ())
      {

        std::string mname = id->name ();

        // Methods that cannot be declared outside the classdef file:
        // - methods with '.' character (e.g. property accessors)
        // - class constructor
        // - 'delete'

        if (mname.find_first_of (".") == std::string::npos
            && mname != "delete"
            && mname != m_curr_class_name)
          {
            // Create a dummy function that is used until the real method
            // is loaded.

            retval = new octave_user_function (symbol_scope (), pl);

            retval->stash_function_name (mname);

            int l = id->line ();
            int c = id->column ();

            retval->stash_fcn_location (l, c);
          }
        else
          bison_error ("invalid external method declaration, an external "
                       "method cannot be the class constructor, 'delete' "
                       "or have a dot (.) character in its name");
      }
    else
      bison_error ("external methods are only allowed in @-folders");

    if (! retval)
      delete id;

    return retval;
  }

  tree_function_def *
  base_parser::finish_classdef_external_method (octave_user_function *fcn,
                                                tree_parameter_list *ret_list,
                                                comment_list *cl)
  {
    if (ret_list)
      fcn->define_ret_list (ret_list);

    if (cl)
      fcn->stash_leading_comment (cl);

    int l = fcn->beginning_line ();
    int c = fcn->beginning_column ();

    return new tree_function_def (fcn, l, c);
  }

  void
  base_parser::finish_classdef_file (tree_classdef *cls,
                                     tree_statement_list *local_fcns)
  {
    if (m_lexer.m_reading_classdef_file)
      m_classdef_object = std::shared_ptr<tree_classdef> (cls);

    if (local_fcns)
      {
        symbol_table& symtab
          = __get_symbol_table__ ("base_parser::finish_classdef_file");

        for (tree_statement *elt : *local_fcns)
          {
            tree_command *cmd = elt->command ();

            tree_function_def *fcn_def
              = dynamic_cast<tree_function_def *> (cmd);

            octave_value ov_fcn = fcn_def->function ();
            octave_function *fcn = ov_fcn.function_value ();
            std::string nm = fcn->name ();
            std::string file = fcn->fcn_file_name ();

            symtab.install_local_function (nm, ov_fcn, file);
          }

        delete local_fcns;
      }
  }

  // Make an index expression.

  tree_index_expression *
  base_parser::make_index_expression (tree_expression *expr,
                                      tree_argument_list *args,
                                      char type)
  {
    tree_index_expression *retval = nullptr;

    if (args && args->has_magic_tilde ())
      {
        delete expr;
        delete args;

        bison_error ("invalid use of empty argument (~) in index expression");
      }
    else
      {
        int l = expr->line ();
        int c = expr->column ();

        if (! expr->is_postfix_indexed ())
          expr->set_postfix_index (type);

        if (expr->is_index_expression ())
          {
            tree_index_expression *tmp
              = dynamic_cast<tree_index_expression *> (expr);

            tmp->append (args, type);

            retval = tmp;
          }
        else
          retval = new tree_index_expression (expr, args, l, c, type);
      }

    return retval;
  }

  // Make an indirect reference expression.

  tree_index_expression *
  base_parser::make_indirect_ref (tree_expression *expr,
                                  const std::string& elt)
  {
    tree_index_expression *retval = nullptr;

    int l = expr->line ();
    int c = expr->column ();

    if (! expr->is_postfix_indexed ())
      expr->set_postfix_index ('.');

    if (expr->is_index_expression ())
      {
        tree_index_expression *tmp
          = dynamic_cast<tree_index_expression *> (expr);

        tmp->append (elt);

        retval = tmp;
      }
    else
      retval = new tree_index_expression (expr, elt, l, c);

    m_lexer.m_looking_at_indirect_ref = false;

    return retval;
  }

  // Make an indirect reference expression with dynamic field name.

  tree_index_expression *
  base_parser::make_indirect_ref (tree_expression *expr,
                                  tree_expression *elt)
  {
    tree_index_expression *retval = nullptr;

    int l = expr->line ();
    int c = expr->column ();

    if (! expr->is_postfix_indexed ())
      expr->set_postfix_index ('.');

    if (expr->is_index_expression ())
      {
        tree_index_expression *tmp
          = dynamic_cast<tree_index_expression *> (expr);

        tmp->append (elt);

        retval = tmp;
      }
    else
      retval = new tree_index_expression (expr, elt, l, c);

    m_lexer.m_looking_at_indirect_ref = false;

    return retval;
  }

  // Make a declaration command.

  tree_decl_command *
  base_parser::make_decl_command (int tok, token *tok_val,
                                  tree_decl_init_list *lst)
  {
    tree_decl_command *retval = nullptr;

    int l = tok_val->line ();
    int c = tok_val->column ();

    if (lst)
      m_lexer.mark_as_variables (lst->variable_names ());

    switch (tok)
      {
      case GLOBAL:
        {
          retval = new tree_decl_command ("global", lst, l, c);
          retval->mark_global ();
        }
        break;

      case PERSISTENT:
        if (m_curr_fcn_depth >= 0)
          {
            retval = new tree_decl_command ("persistent", lst, l, c);
            retval->mark_persistent ();
          }
        else
          {
            if (m_lexer.m_reading_script_file)
              warning ("ignoring persistent declaration near line %d of file '%s'",
                       l, m_lexer.m_fcn_file_full_name.c_str ());
            else
              warning ("ignoring persistent declaration near line %d", l);
          }
        break;

      default:
        panic_impossible ();
        break;
      }

    return retval;
  }

  bool
  base_parser::validate_param_list (tree_parameter_list *lst,
                                    tree_parameter_list::in_or_out type)
  {
    std::set<std::string> dict;

    for (tree_decl_elt *elt : *lst)
      {
        tree_identifier *id = elt->ident ();

        if (id)
          {
            std::string name = id->name ();

            if (id->is_black_hole ())
              {
                if (type != tree_parameter_list::in)
                  {
                    bison_error ("invalid use of ~ in output list");
                    return false;
                  }
              }
            else if (dict.find (name) != dict.end ())
              {
                bison_error ("'" + name
                             + "' appears more than once in parameter list");
                return false;
              }
            else
              dict.insert (name);
          }
      }

    std::string va_type = (type == tree_parameter_list::in
                           ? "varargin" : "varargout");

    size_t len = lst->length ();

    if (len > 0)
      {
        tree_decl_elt *elt = lst->back ();

        tree_identifier *id = elt->ident ();

        if (id && id->name () == va_type)
          {
            if (len == 1)
              lst->mark_varargs_only ();
            else
              lst->mark_varargs ();

            tree_parameter_list::iterator p = lst->end ();
            --p;
            delete *p;
            lst->erase (p);
          }
      }

    return true;
  }

  bool
  base_parser::validate_array_list (tree_expression *e)
  {
    bool retval = true;

    tree_array_list *al = dynamic_cast<tree_array_list *> (e);

    for (tree_argument_list* row : *al)
      {
        if (row && row->has_magic_tilde ())
          {
            retval = false;

            if (e->is_matrix ())
              bison_error ("invalid use of tilde (~) in matrix expression");
            else
              bison_error ("invalid use of tilde (~) in cell expression");

            break;
          }
      }

    return retval;
  }

  tree_argument_list *
  base_parser::validate_matrix_for_assignment (tree_expression *e)
  {
    tree_argument_list *retval = nullptr;

    if (e->is_constant ())
      {
        tree_evaluator& tw
          = __get_evaluator__ ("validate_matrix_for_assignment");

        octave_value ov = e->evaluate (tw);

        delete e;

        if (ov.isempty ())
          bison_error ("invalid empty left hand side of assignment");
        else
          bison_error ("invalid constant left hand side of assignment");
      }
    else
      {
        bool is_simple_assign = true;

        tree_argument_list *tmp = nullptr;

        if (e->is_matrix ())
          {
            tree_matrix *mat = dynamic_cast<tree_matrix *> (e);

            if (mat && mat->size () == 1)
              {
                tmp = mat->front ();
                mat->pop_front ();
                delete e;
                is_simple_assign = false;
              }
          }
        else
          tmp = new tree_argument_list (e);

        if (tmp && tmp->is_valid_lvalue_list ())
          {
            m_lexer.mark_as_variables (tmp->variable_names ());
            retval = tmp;
          }
        else
          {
            delete tmp;

            bison_error ("invalid left hand side of assignment");
          }

        if (retval && is_simple_assign)
          retval->mark_as_simple_assign_lhs ();
      }

    return retval;
  }

  // Finish building an array_list.

  tree_expression *
  base_parser::finish_array_list (tree_array_list *array_list,
                                  token */*open_delim*/, token *close_delim)
  {
    tree_expression *retval = array_list;

    array_list->set_location (close_delim->line (), close_delim->column ());

    if (array_list->all_elements_are_constant ())
      {
        interpreter& interp = __get_interpreter__ ("finish_array_list");

        try
          {
            // If the evaluation generates a warning message, restore
            // the previous value of last_warning_message and skip the
            // conversion to a constant value.

            unwind_protect frame;

            error_system& es = interp.get_error_system ();

            frame.add_method (es, &error_system::set_last_warning_message,
                              es.last_warning_message (""));

            frame.add_method (es, &error_system::set_discard_warning_messages,
                              es.discard_warning_messages (true));

            tree_evaluator& tw = interp.get_evaluator ();

            octave_value tmp = array_list->evaluate (tw);

            std::string msg = es.last_warning_message ();

            if (msg.empty ())
              {
                tree_constant *tc_retval
                  = new tree_constant (tmp, close_delim->line (),
                                       close_delim->column ());

                std::ostringstream buf;

                tree_print_code tpc (buf);

                array_list->accept (tpc);

                tc_retval->stash_original_text (buf.str ());

                delete array_list;

                retval = tc_retval;
              }
          }
        catch (const execution_exception&)
          {
            interp.recover_from_exception ();
          }
      }

    return retval;
  }

  // Finish building a matrix list.

  tree_expression *
  base_parser::finish_matrix (tree_matrix *m, token *open_delim,
                              token *close_delim)
  {
    return (m
            ? finish_array_list (m, open_delim, close_delim)
            : new tree_constant (octave_null_matrix::instance,
                                 close_delim->line (), close_delim->column ()));
  }

  // Finish building a cell list.

  tree_expression *
  base_parser::finish_cell (tree_cell *c, token *open_delim,
                            token *close_delim)
  {
    return (c
            ? finish_array_list (c, open_delim, close_delim)
            : new tree_constant (octave_value (Cell ()),
                                 close_delim->line (), close_delim->column ()));
  }

  tree_statement_list *
  base_parser::set_stmt_print_flag (tree_statement_list *list,
                                    char sep, bool warn_missing_semi)
  {
    tree_statement *tmp = list->back ();

    switch (sep)
      {
      case ';':
        tmp->set_print_flag (false);
        break;

      case 0:
      case ',':
      case '\n':
        tmp->set_print_flag (true);
        if (warn_missing_semi)
          maybe_warn_missing_semi (list);
        break;

      default:
        warning ("unrecognized separator type!");
        break;
      }

    // Even if a statement is null, we add it to the list then remove it
    // here so that the print flag is applied to the correct statement.

    if (tmp->is_null_statement ())
      {
        list->pop_back ();
        delete tmp;
      }

    return list;
  }

  // Finish building a statement.
  template <typename T>
  tree_statement *
  base_parser::make_statement (T *arg)
  {
    comment_list *comment = m_lexer.get_comment ();

    return new tree_statement (arg, comment);
  }

  tree_statement_list *
  base_parser::make_statement_list (tree_statement *stmt)
  {
    return new tree_statement_list (stmt);
  }

  tree_statement_list *
  base_parser::append_statement_list (tree_statement_list *list,
                                      char sep, tree_statement *stmt,
                                      bool warn_missing_semi)
  {
    set_stmt_print_flag (list, sep, warn_missing_semi);

    list->append (stmt);

    return list;
  }

  void
  base_parser::disallow_command_syntax (void)
  {
    m_lexer.m_allow_command_syntax = false;
  }

  // FIXME: this function partially duplicates do_dbtype in debug.cc.
  static std::string
  get_file_line (const std::string& name, int line)
  {
    // NAME should be an absolute file name and the file should exist.

    std::string ascii_fname = sys::get_ASCII_filename (name);

    std::ifstream fs (ascii_fname.c_str (), std::ios::in);

    std::string text;

    if (fs)
      {
        int i = 1;

        do
          {
            if (! std::getline (fs, text))
              {
                text = "";
                break;
              }
          }
        while (i++ < line);
      }

    return text;
  }

  void
  base_parser::bison_error (const std::string& str)
  {
    bison_error (str, m_lexer.m_filepos);
  }

  void
  base_parser::bison_error (const std::string& str, const filepos& pos)
  {
    bison_error (str, pos.line (), pos.column ());
  }

  void
  base_parser::bison_error (const std::string& str, int err_line, int err_col)
  {
    std::ostringstream output_buf;

    if (m_lexer.m_reading_fcn_file || m_lexer.m_reading_script_file
        || m_lexer.m_reading_classdef_file)
      output_buf << "parse error near line " << err_line
                 << " of file " << m_lexer.m_fcn_file_full_name;
    else
      output_buf << "parse error:";

    if (str != "parse error")
      output_buf << "\n\n  " << str;

    output_buf << "\n\n";

    std::string curr_line;

    if (m_lexer.m_reading_fcn_file || m_lexer.m_reading_script_file
        || m_lexer.m_reading_classdef_file)
      curr_line = get_file_line (m_lexer.m_fcn_file_full_name, err_line);

    if (! curr_line.empty ())
      {
        // FIXME: we could do better if we just cached lines from the
        // input file in a list.  See also functions for managing input
        // buffers in lex.ll.

        size_t len = curr_line.length ();

        if (curr_line[len-1] == '\n')
          curr_line.resize (len-1);

        // Print the line, maybe with a pointer near the error token.

        output_buf << ">>> " << curr_line << "\n";

        if (err_col == 0)
          err_col = len;

        for (int i = 0; i < err_col + 3; i++)
          output_buf << " ";

        output_buf << "^";
      }

    output_buf << "\n";

    m_parse_error_msg = output_buf.str ();
  }

  int
  parser::run (void)
  {
    int status = -1;

    yypstate *pstate = static_cast<yypstate *> (m_parser_state);

    try
      {
        status = octave_pull_parse (pstate, *this);
      }
    catch (const execution_exception&)
      {
        // FIXME: In previous versions, we emitted a parse error here
        // but that is not always correct because the error could have
        // happened inside a GUI callback functions executing in the
        // readline event_hook loop.  Maybe we need a separate exception
        // class for parse errors?

        throw;
      }
    catch (const exit_exception&)
      {
        throw;
      }
    catch (const interrupt_exception&)
      {
        throw;
      }
    catch (...)
      {
        std::string file = m_lexer.m_fcn_file_full_name;

        if (file.empty ())
          error ("unexpected exception while parsing input");
        else
          error ("unexpected exception while parsing %s", file.c_str ());
      }

    if (status != 0)
      parse_error ("%s", m_parse_error_msg.c_str ());

    return status;
  }

  // Parse input from INPUT.  Pass TRUE for EOF if the end of INPUT should
  // finish the parse.

  int
  push_parser::run (const std::string& input, bool eof)
  {
    int status = -1;

    dynamic_cast<push_lexer&> (m_lexer).append_input (input, eof);

    do
      {
        YYSTYPE lval;

        int token = octave_lex (&lval, m_lexer.m_scanner);

        if (token < 0)
          {
            status = -1;

            if (! eof && m_lexer.at_end_of_buffer ())
              return status;

            break;
          }

        yypstate *pstate = static_cast<yypstate *> (m_parser_state);

        try
          {
            status = octave_push_parse (pstate, token, &lval, *this);
          }
        catch (execution_exception& e)
          {
            std::string file = m_lexer.m_fcn_file_full_name;

            if (file.empty ())
              error (e, "parse error");
            else
              error (e, "parse error in %s", file.c_str ());
          }
        catch (const exit_exception&)
          {
            throw;
          }
        catch (interrupt_exception &)
          {
            throw;
          }
        catch (...)
          {
            std::string file = m_lexer.m_fcn_file_full_name;

            if (file.empty ())
              error ("unexpected exception while parsing input");
            else
              error ("unexpected exception while parsing %s", file.c_str ());
          }
      }
    while (status == YYPUSH_MORE);

    if (status != 0)
      parse_error ("%s", m_parse_error_msg.c_str ());

    return status;
  }

  octave_value
  parse_fcn_file (interpreter& interp, const std::string& full_file,
                  const std::string& file, const std::string& dir_name,
                  const std::string& dispatch_type,
                  const std::string& package_name, bool require_file,
                  bool force_script, bool autoload, bool relative_lookup)
  {
    octave_value retval;

    FILE *ffile = nullptr;

    if (! full_file.empty ())
      ffile = sys::fopen (full_file, "rb");

    if (! ffile)
      {
        if (require_file)
          error ("no such file, '%s'", full_file.c_str ());

        return octave_value ();
      }

    unwind_action act ([ffile] (void)
                       {
                         fclose (ffile);
                       });

    parser parser (ffile, interp);

    parser.m_curr_class_name = dispatch_type;
    parser.m_curr_package_name = package_name;
    parser.m_autoloading = autoload;
    parser.m_fcn_file_from_relative_lookup = relative_lookup;

    parser.m_lexer.m_force_script = force_script;
    parser.m_lexer.prep_for_file ();
    parser.m_lexer.m_parsing_class_method = ! dispatch_type.empty ();

    parser.m_lexer.m_fcn_file_name = file;
    parser.m_lexer.m_fcn_file_full_name = full_file;
    parser.m_lexer.m_dir_name = dir_name;
    parser.m_lexer.m_package_name = package_name;

    int err = parser.run ();

    if (err)
      error ("parse error while reading file %s", full_file.c_str ());

    octave_value ov_fcn = parser.m_primary_fcn;

    if (parser.m_lexer.m_reading_classdef_file
        && parser.classdef_object ())
      {
        // Convert parse tree for classdef object to
        // meta.class info (and stash it in the symbol
        // table?).  Return pointer to constructor?

        if (ov_fcn.is_defined ())
          panic_impossible ();

        bool is_at_folder = ! dispatch_type.empty ();

        std::shared_ptr<tree_classdef> cdef_obj
          = parser.classdef_object();

        return cdef_obj->make_meta_class (interp, is_at_folder);
      }
    else if (ov_fcn.is_defined ())
      {
        octave_function *fcn = ov_fcn.function_value ();

        fcn->maybe_relocate_end ();

        if (parser.m_parsing_subfunctions)
          {
            if (! parser.m_endfunction_found)
              parser.m_subfunction_names.reverse ();

            fcn->stash_subfunction_names (parser.m_subfunction_names);
          }

        return ov_fcn;
      }

    return octave_value ();
  }

  // Maybe print a warning if an assignment expression is used as the
  // test in a logical expression.

  void
  base_parser::maybe_warn_assign_as_truth_value (tree_expression *expr)
  {
    if (expr->is_assignment_expression ()
        && expr->paren_count () < 2)
      {
        if (m_lexer.m_fcn_file_full_name.empty ())
          warning_with_id
            ("Octave:assign-as-truth-value",
             "suggest parenthesis around assignment used as truth value");
        else
          warning_with_id
            ("Octave:assign-as-truth-value",
             "suggest parenthesis around assignment used as truth value near line %d, column %d in file '%s'",
             expr->line (), expr->column (), m_lexer.m_fcn_file_full_name.c_str ());
      }
  }

  // Maybe print a warning about switch labels that aren't constants.

  void
  base_parser::maybe_warn_variable_switch_label (tree_expression *expr)
  {
    if (! expr->is_constant ())
      {
        if (m_lexer.m_fcn_file_full_name.empty ())
          warning_with_id ("Octave:variable-switch-label",
                           "variable switch label");
        else
          warning_with_id
            ("Octave:variable-switch-label",
             "variable switch label near line %d, column %d in file '%s'",
             expr->line (), expr->column (), m_lexer.m_fcn_file_full_name.c_str ());
      }
  }

  void
  base_parser::maybe_warn_missing_semi (tree_statement_list *t)
  {
    if (m_curr_fcn_depth >= 0)
      {
        tree_statement *tmp = t->back ();

        if (tmp->is_expression ())
          warning_with_id
            ("Octave:missing-semicolon",
             "missing semicolon near line %d, column %d in file '%s'",
             tmp->line (), tmp->column (), m_lexer.m_fcn_file_full_name.c_str ());
      }
  }

  std::string
  get_help_from_file (const std::string& nm, bool& symbol_found,
                      std::string& full_file)
  {
    std::string retval;

    full_file = fcn_file_in_path (nm);

    std::string file = full_file;

    size_t file_len = file.length ();

    if ((file_len > 4 && file.substr (file_len-4) == ".oct")
        || (file_len > 4 && file.substr (file_len-4) == ".mex")
        || (file_len > 2 && file.substr (file_len-2) == ".m"))
      {
        file = sys::env::base_pathname (file);
        file = file.substr (0, file.find_last_of ('.'));

        size_t pos = file.find_last_of (sys::file_ops::dir_sep_str ());
        if (pos != std::string::npos)
          file = file.substr (pos+1);
      }

    if (! file.empty ())
      {
        interpreter& interp = __get_interpreter__ ("get_help_from_file");

        symbol_found = true;

        octave_value ov_fcn
          = parse_fcn_file (interp, full_file, file, "", "", "", true,
                            false, false, false);

        if (ov_fcn.is_defined ())
          {
            octave_function *fcn = ov_fcn.function_value ();

            if (fcn)
              retval = fcn->doc_string ();
          }
      }

    return retval;
  }

  std::string
  get_help_from_file (const std::string& nm, bool& symbol_found)
  {
    std::string file;
    return get_help_from_file (nm, symbol_found, file);
  }

  octave_value
  load_fcn_from_file (const std::string& file_name,
                      const std::string& dir_name,
                      const std::string& dispatch_type,
                      const std::string& package_name,
                      const std::string& fcn_name, bool autoload)
  {
    octave_value retval;

    unwind_protect frame;

    std::string nm = file_name;

    size_t nm_len = nm.length ();

    std::string file;

    bool relative_lookup = false;

    file = nm;

    if ((nm_len > 4 && nm.substr (nm_len-4) == ".oct")
        || (nm_len > 4 && nm.substr (nm_len-4) == ".mex")
        || (nm_len > 2 && nm.substr (nm_len-2) == ".m"))
      {
        nm = sys::env::base_pathname (file);
        nm = nm.substr (0, nm.find_last_of ('.'));

        size_t pos = nm.find_last_of (sys::file_ops::dir_sep_str ());
        if (pos != std::string::npos)
          nm = nm.substr (pos+1);
      }

    relative_lookup = ! sys::env::absolute_pathname (file);

    file = sys::env::make_absolute (file);

    int len = file.length ();

    interpreter& interp = __get_interpreter__ ("load_fcn_from_file");

    dynamic_loader& dyn_loader = interp.get_dynamic_loader ();

    if (len > 4 && file.substr (len-4, len-1) == ".oct")
      {
        if (autoload && ! fcn_name.empty ())
          nm = fcn_name;

        octave_function *tmpfcn
          = dyn_loader.load_oct (nm, file, relative_lookup);

        if (tmpfcn)
          {
            tmpfcn->stash_package_name (package_name);
            retval = octave_value (tmpfcn);
          }
      }
    else if (len > 4 && file.substr (len-4, len-1) == ".mex")
      {
        // Temporarily load m-file version of mex-file, if it exists,
        // to get the help-string to use.

        std::string doc_string;

        octave_value ov_fcn
          = parse_fcn_file (interp, file.substr (0, len - 2), nm, dir_name,
                            dispatch_type, package_name, false,
                            autoload, autoload, relative_lookup);

        if (ov_fcn.is_defined ())
          {
            octave_function *tmpfcn = ov_fcn.function_value ();

            if (tmpfcn)
              doc_string = tmpfcn->doc_string ();
          }

        octave_function *tmpfcn
          = dyn_loader.load_mex (nm, file, relative_lookup);

        if (tmpfcn)
          {
            tmpfcn->document (doc_string);
            tmpfcn->stash_package_name (package_name);

            retval = octave_value (tmpfcn);
          }
      }
    else if (len > 2)
      {
        retval = parse_fcn_file (interp, file, nm, dir_name,
                                 dispatch_type, package_name, true,
                                 autoload, autoload, relative_lookup);
      }

    return retval;
  }
}

DEFMETHOD (autoload, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn  {} {@var{autoload_map} =} autoload ()
@deftypefnx {} {} autoload (@var{function}, @var{file})
@deftypefnx {} {} autoload (@dots{}, "remove")
Define @var{function} to autoload from @var{file}.

The second argument, @var{file}, should be an absolute filename or a file
name in the same directory as the function or script from which the autoload
command was run.  @var{file} @emph{should not} depend on the Octave load
path.

Normally, calls to @code{autoload} appear in PKG_ADD script files that are
evaluated when a directory is added to Octave's load path.  To avoid having
to hardcode directory names in @var{file}, if @var{file} is in the same
directory as the PKG_ADD script then

@example
autoload ("foo", "bar.oct");
@end example

@noindent
will load the function @code{foo} from the file @code{bar.oct}.  The above
usage when @code{bar.oct} is not in the same directory, or usages such as

@example
autoload ("foo", file_in_loadpath ("bar.oct"))
@end example

@noindent
are strongly discouraged, as their behavior may be unpredictable.

With no arguments, return a structure containing the current autoload map.

If a third argument @qcode{"remove"} is given, the function is cleared and
not loaded anymore during the current Octave session.

@seealso{PKG_ADD}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin == 1 || nargin > 3)
    print_usage ();

  octave::tree_evaluator& tw = interp.get_evaluator ();

  if (nargin == 0)
    return octave_value (tw.get_autoload_map ());
  else
    {
      string_vector argv = args.make_argv ("autoload");

      if (nargin == 2)
        tw.add_autoload (argv[1], argv[2]);
      else if (nargin == 3)
        {
          if (argv[3] != "remove")
            error_with_id ("Octave:invalid-input-arg",
                           "autoload: third argument can only be 'remove'");

          tw.remove_autoload (argv[1], argv[2]);
        }
    }

  return octave_value_list ();
}

DEFMETHOD (mfilename, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn  {} {} mfilename ()
@deftypefnx {} {} mfilename ("fullpath")
@deftypefnx {} {} mfilename ("fullpathext")
Return the name of the currently executing file.

The base name of the currently executing script or function is returned without
any extension.  If called from outside an m-file, such as the command line,
return the empty string.

Given the argument @qcode{"fullpath"}, include the directory part of the
filename, but not the extension.

Given the argument @qcode{"fullpathext"}, include the directory part of
the filename and the extension.
@seealso{inputname, dbstack}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin > 1)
    print_usage ();

  std::string opt;

  if (nargin == 1)
    opt = args(0).xstring_value ("mfilename: option argument must be a string");

  return octave_value (interp.mfilename (opt));
}

namespace octave
{
  // Execute the contents of a script file.  For compatibility with
  // Matlab, also execute a function file by calling the function it
  // defines with no arguments and nargout = 0.

  void
  source_file (const std::string& file_name, const std::string& context,
               bool verbose, bool require_file)
  {
    interpreter& interp = __get_interpreter__ ("source_file");

    interp.source_file (file_name, context, verbose, require_file);
  }
}

DEFMETHOD (source, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn  {} {} source (@var{file})
@deftypefnx {} {} source (@var{file}, @var{context})
Parse and execute the contents of @var{file}.

Without specifying @var{context}, this is equivalent to executing commands
from a script file, but without requiring the file to be named
@file{@var{file}.m} or to be on the execution path.

Instead of the current context, the script may be executed in either the
context of the function that called the present function
(@qcode{"caller"}), or the top-level context (@qcode{"base"}).
@seealso{run}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin < 1 || nargin > 2)
    print_usage ();

  std::string file_name
    = args(0).xstring_value ("source: FILE must be a string");

  std::string context;
  if (nargin == 2)
    context = args(1).xstring_value ("source: CONTEXT must be a string");

  interp.source_file (file_name, context);

  return octave_value_list ();
}

namespace octave
{
  //! Evaluate an Octave function (built-in or interpreted) and return
  //! the list of result values.
  //!
  //! @param name The name of the function to call.
  //! @param args The arguments to the function.
  //! @param nargout The number of output arguments expected.
  //! @return A list of output values.  The length of the list is not
  //!         necessarily the same as @c nargout.

  octave_value_list
  feval (const char *name, const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (name, args, nargout);
  }

  octave_value_list
  feval (const std::string& name, const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (name, args, nargout);
  }

  octave_value_list
  feval (octave_function *fcn, const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (fcn, args, nargout);
  }

  octave_value_list
  feval (const octave_value& val, const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (val, args, nargout);
  }

  octave_value_list
  feval (const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (args, nargout);
  }
}

DEFMETHOD (feval, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn {} {} feval (@var{name}, @dots{})
Evaluate the function named @var{name}.

Any arguments after the first are passed as inputs to the named function.
For example,

@example
@group
feval ("acos", -1)
     @result{} 3.1416
@end group
@end example

@noindent
calls the function @code{acos} with the argument @samp{-1}.

The function @code{feval} can also be used with function handles of any sort
(@pxref{Function Handles}).  Historically, @code{feval} was the only way to
call user-supplied functions in strings, but function handles are now
preferred due to the cleaner syntax they offer.  For example,

@example
@group
@var{f} = @@exp;
feval (@var{f}, 1)
    @result{} 2.7183
@var{f} (1)
    @result{} 2.7183
@end group
@end example

@noindent
are equivalent ways to call the function referred to by @var{f}.  If it
cannot be predicted beforehand whether @var{f} is a function handle,
function name in a string, or inline function then @code{feval} can be used
instead.
@end deftypefn */)
{
  if (args.length () == 0)
    print_usage ();

  return interp.feval (args, nargout);
}

DEFMETHOD (builtin, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn {} {[@dots{}] =} builtin (@var{f}, @dots{})
Call the base function @var{f} even if @var{f} is overloaded to another
function for the given type signature.

This is normally useful when doing object-oriented programming and there is
a requirement to call one of Octave's base functions rather than the
overloaded one of a new class.

A trivial example which redefines the @code{sin} function to be the
@code{cos} function shows how @code{builtin} works.

@example
@group
sin (0)
  @result{} 0
function y = sin (x), y = cos (x); endfunction
sin (0)
  @result{} 1
builtin ("sin", 0)
  @result{} 0
@end group
@end example
@end deftypefn */)
{
  octave_value_list retval;

  if (args.length () == 0)
    print_usage ();

  const std::string name (args(0).xstring_value ("builtin: function name (F) must be a string"));

  octave::symbol_table& symtab = interp.get_symbol_table ();

  octave_value fcn = symtab.builtin_find (name);

  if (fcn.is_defined ())
    retval = interp.feval (fcn.function_value (), args.splice (0, 1), nargout);
  else
    error ("builtin: lookup for symbol '%s' failed", name.c_str ());

  return retval;
}

namespace octave
{
  octave_value_list
  eval_string (const std::string& eval_str, bool silent,
               int& parse_status, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("eval_string");

    return interp.eval_string (eval_str, silent, parse_status, nargout);
  }

  octave_value
  eval_string (const std::string& eval_str, bool silent, int& parse_status)
  {
    interpreter& interp = __get_interpreter__ ("eval_string");

    return interp.eval_string (eval_str, silent, parse_status);
  }

  void
  cleanup_statement_list (tree_statement_list **lst)
  {
    if (*lst)
      {
        delete *lst;
        *lst = nullptr;
      }
  }
}

DEFMETHOD (eval, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn  {} {} eval (@var{try})
@deftypefnx {} {} eval (@var{try}, @var{catch})
Parse the string @var{try} and evaluate it as if it were an Octave
program.

If execution fails, evaluate the optional string @var{catch}.

The string @var{try} is evaluated in the current context, so any results
remain available after @code{eval} returns.

The following example creates the variable @var{A} with the approximate
value of 3.1416 in the current workspace.

@example
eval ("A = acos(-1);");
@end example

If an error occurs during the evaluation of @var{try} then the @var{catch}
string is evaluated, as the following example shows:

@example
@group
eval ('error ("This is a bad example");',
      'printf ("This error occurred:\n%s\n", lasterr ());');
     @print{} This error occurred:
        This is a bad example
@end group
@end example

Programming Note: if you are only using @code{eval} as an error-capturing
mechanism, rather than for the execution of arbitrary code strings,
Consider using try/catch blocks or unwind_protect/unwind_protect_cleanup
blocks instead.  These techniques have higher performance and don't
introduce the security considerations that the evaluation of arbitrary code
does.
@seealso{evalin, evalc, assignin, feval}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin < 1 || nargin > 2)
    print_usage ();

  if (! args(0).is_string () || args(0).rows () > 1 || args(0).ndims () != 2)
    error ("eval: TRY must be a string");

  std::string try_code = args(0).string_value ();

  if (nargin == 1)
    return interp.eval (try_code, nargout);
  else
    {
      if (! args(1).is_string () || args(1).rows () > 1
          || args(1).ndims () != 2)
        error ("eval: CATCH must be a string");

      std::string catch_code = args(1).string_value ();

      return interp.eval (try_code, catch_code, nargout);
    }
}

/*

%!shared x
%! x = 1;

%!assert (eval ("x"), 1)
%!assert (eval ("x;"))
%!assert (eval ("x;"), 1)

%!test
%! y = eval ("x");
%! assert (y, 1);

%!test
%! y = eval ("x;");
%! assert (y, 1);

%!test
%! eval ("x = 1;");
%! assert (x,1);

%!test
%! eval ("flipud = 2;");
%! assert (flipud, 2);

%!function y = __f ()
%!  eval ("flipud = 2;");
%!  y = flipud;
%!endfunction
%!assert (__f(), 2)

%!test <*35645>
%! [a,] = gcd (1,2);
%! [a,b,] = gcd (1, 2);

## Can't assign to a keyword
%!error eval ("switch = 13;")

%!shared str
%! str = "disp ('hello');";
%! str(:,:,2) = str(:,:,1);

%!error <TRY must be a string> eval (1)
%!error <TRY must be a string> eval (['a';'b'])
%!error <TRY must be a string> eval (str)

%!error <CATCH must be a string> eval (str(:,:,1), 1)
%!error <CATCH must be a string> eval (str(:,:,1), ['a';'b'])
%!error <CATCH must be a string> eval (str(:,:,1), str)

*/

DEFMETHOD (assignin, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn {} {} assignin (@var{context}, @var{varname}, @var{value})
Assign @var{value} to @var{varname} in context @var{context}, which
may be either @qcode{"base"} or @qcode{"caller"}.
@seealso{evalin}
@end deftypefn */)
{
  if (args.length () != 3)
    print_usage ();

  std::string context
    = args(0).xstring_value ("assignin: CONTEXT must be a string");

  std::string varname
    = args(1).xstring_value ("assignin: VARNAME must be a string");

  interp.assignin (context, varname, args(2));

  return octave_value_list ();
}

/*

%!error assignin ("base", "switch", "13")

*/

DEFMETHOD (evalin, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn  {} {} evalin (@var{context}, @var{try})
@deftypefnx {} {} evalin (@var{context}, @var{try}, @var{catch})
Like @code{eval}, except that the expressions are evaluated in the context
@var{context}, which may be either @qcode{"caller"} or @qcode{"base"}.
@seealso{eval, assignin}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin < 2 || nargin > 3)
    print_usage ();

  std::string context
    = args(0).xstring_value ("evalin: CONTEXT must be a string");

  std::string try_code
    = args(1).xstring_value ("evalin: TRY must be a string");

  if (nargin == 3)
    {
      std::string catch_code
        = args(2).xstring_value ("evalin: CATCH must be a string");

      return interp.evalin (context, try_code, catch_code, nargout);
    }

  return interp.evalin (context, try_code, nargout);
}

DEFMETHOD (evalc, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn  {} {@var{s} =} evalc (@var{try})
@deftypefnx {} {@var{s} =} evalc (@var{try}, @var{catch})
Parse and evaluate the string @var{try} as if it were an Octave program,
while capturing the output into the return variable @var{s}.

If execution fails, evaluate the optional string @var{catch}.

This function behaves like @code{eval}, but any output or warning messages
which would normally be written to the console are captured and returned in
the string @var{s}.

The @code{diary} is disabled during the execution of this function.  When
@code{system} is used, any output produced by external programs is
@emph{not} captured, unless their output is captured by the @code{system}
function itself.

@example
@group
s = evalc ("t = 42"), t
  @result{} s = t =  42

  @result{} t =  42
@end group
@end example
@seealso{eval, diary}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin == 0 || nargin > 2)
    print_usage ();

  // Flush pending output and redirect stdout/stderr to capturing
  // buffer.

  octave_stdout.flush ();
  std::cerr.flush ();

  std::stringbuf buffer;

  std::streambuf *old_out_buf = octave_stdout.rdbuf (&buffer);
  std::streambuf *old_err_buf = std::cerr.rdbuf (&buffer);

  // Restore previous output buffers no matter how control exits this
  // function.  There's no need to flush here.  That has already
  // happened for the normal execution path.  If an error happens during
  // the eval, then the message is stored in the exception object and we
  // will display it later, after the buffers have been restored.

  octave::unwind_action act ([old_out_buf, old_err_buf] (void)
                             {
                               octave_stdout.rdbuf (old_out_buf);
                               std::cerr.rdbuf (old_err_buf);
                             });

  // Call standard eval function.

  int eval_nargout = std::max (0, nargout - 1);

  octave_value_list retval = Feval (interp, args, eval_nargout);

  // Make sure we capture all pending output.

  octave_stdout.flush ();
  std::cerr.flush ();

  retval.prepend (buffer.str ());

  return retval;
}

/*

%!test
%! [old_fmt, old_spacing] = format ();
%! unwind_protect
%!   format short;
%!   str = evalc ("1");
%!   assert (str, "ans = 1\n");
%! unwind_protect_cleanup
%!   format (old_fmt);
%!   format (old_spacing);
%! end_unwind_protect

%!assert (evalc ("1;"), "")

%!test
%! [s, y] = evalc ("1");
%! assert (s, "");
%! assert (y, 1);

%!test
%! [s, y] = evalc ("1;");
%! assert (s, "");
%! assert (y, 1);

%!test
%! [old_fmt, old_spacing] = format ();
%! unwind_protect
%!   format short;
%!   str = evalc ("y = 2");
%!   assert (str, "y = 2\n");
%!   assert (y, 2);
%! unwind_protect_cleanup
%!   format (old_fmt);
%!   format (old_spacing);
%! end_unwind_protect

%!test
%! assert (evalc ("y = 3;"), "");
%! assert (y, 3);

%!test
%! [s, a, b] = evalc ("deal (1, 2)");
%! assert (s, "");
%! assert (a, 1);
%! assert (b, 2);

%!function [a, b] = __f_evalc ()
%!  printf ("foo");
%!  fprintf (stdout, "bar ");
%!  disp (pi);
%!  a = 1;
%!  b = 2;
%!endfunction
%!test
%! [old_fmt, old_spacing] = format ();
%! unwind_protect
%!   format short;
%!   [s, a, b] = evalc ("__f_evalc ()");
%!   assert (s, "foobar 3.1416\n");
%!   assert (a, 1);
%!   assert (b, 2);
%! unwind_protect_cleanup
%!   format (old_fmt);
%!   format (old_spacing);
%! end_unwind_protect

%!error <foo> (evalc ("error ('foo')"))
%!error <bar> (evalc ("error ('foo')", "error ('bar')"))

%!test
%! warning ("off", "quiet", "local");
%! str = evalc ("warning ('foo')");
%! assert (str(1:13), "warning: foo\n");

%!test
%! warning ("off", "quiet", "local");
%! str = evalc ("error ('foo')", "warning ('bar')");
%! assert (str(1:13), "warning: bar\n");

%!error evalc ("switch = 13;")

*/

DEFUN (__parser_debug_flag__, args, nargout,
       doc: /* -*- texinfo -*-
@deftypefn  {} {@var{val} =} __parser_debug_flag__ ()
@deftypefnx {} {@var{old_val} =} __parser_debug_flag__ (@var{new_val})
Query or set the internal flag that determines whether Octave's parser
prints debug information as it processes an expression.
@seealso{__lexer_debug_flag__}
@end deftypefn */)
{
  octave_value retval;

  bool debug_flag = octave_debug;

  retval = set_internal_variable (debug_flag, args, nargout,
                                  "__parser_debug_flag__");

  octave_debug = debug_flag;

  return retval;
}

DEFMETHOD (__parse_file__, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn {} {} __parse_file__ (@var{file}, @var{verbose})
Undocumented internal function.
@end deftypefn */)
{
  octave_value retval;

  int nargin = args.length ();

  if (nargin < 1 || nargin > 2)
    print_usage ();

  std::string file = args(0).xstring_value ("__parse_file__: expecting filename as argument");

  std::string full_file
      = octave::sys::file_ops::tilde_expand (file);

  full_file = octave::sys::env::make_absolute (full_file);

  std::string dir_name;

  size_t file_len = file.length ();

  if ((file_len > 4 && file.substr (file_len-4) == ".oct")
      || (file_len > 4 && file.substr (file_len-4) == ".mex")
      || (file_len > 2 && file.substr (file_len-2) == ".m"))
    {
      file = octave::sys::env::base_pathname (file);
      file = file.substr (0, file.find_last_of ('.'));

      size_t pos = file.find_last_of (octave::sys::file_ops::dir_sep_str ());
      if (pos != std::string::npos)
        {
          dir_name = file.substr (0, pos);
          file = file.substr (pos+1);
        }
    }

  if (nargin == 2)
    octave_stdout << "parsing " << full_file << std::endl;

  octave_value ov_fcn
    = parse_fcn_file (interp, full_file, file, dir_name, "", "", true,
                      false, false, false);

  return retval;
}
